import _extends from "@babel/runtime-corejs3/helpers/extends";
import _spliceInstanceProperty from "@babel/runtime-corejs3/core-js/instance/splice";
import { createElementVNode as _$ce, noop as _$no, createVNode as _$cv, className as _$cn } from 'intact-vue-next';
import { getRestProps, mapChildren } from '../utils';
import { BreadcrumbItem } from './item';
import makeStyles from './styles';
export default function ($props, $blocks, $__proto__) {
  var _classNameObj;

  $blocks || ($blocks = {});
  $props || ($props = {});
  var $this = this;
  var _$blocks = {};
  var __$blocks = {};

  var _this$get = this.get(),
      children = _this$get.children,
      separator = _this$get.separator,
      className = _this$get.className;

  var classNameObj = (_classNameObj = {
    'k-breadcrumb': true
  }, _classNameObj[className] = className, _classNameObj[makeStyles()] = true, _classNameObj);

  var separatorVNode = _$ce(2, 'span', (_$blocks['separator'] = function ($super) {
    return separator;
  }, __$blocks['separator'] = function ($super, data) {
    var block = $blocks['separator'];

    var callBlock = function callBlock() {
      return _$blocks['separator'].call($this, $super, data);
    };

    return block ? block.call($this, callBlock, data) : callBlock();
  }, __$blocks['separator'](_$no)), 0, 'k-breadcrumb-separator');

  var vNodes = [];
  var lastIndex = -1;
  var separatorAmount = 0;
  mapChildren(children, function (vNode, index) {
    vNodes.push(vNode);

    if (vNode.tag === BreadcrumbItem) {
      lastIndex = index;
      separatorAmount++;
      vNodes.push(separatorVNode);
    }
  }); // remove the last BreadcrumbItem's separator,
  // because it may have other vNodes follow the last BreadcrumbItem.
  // we record the last separator's index and splice array like bellow to remove it

  if (lastIndex > -1) {
    _spliceInstanceProperty(vNodes).call(vNodes, lastIndex + separatorAmount, 1);
  }

  return _$cv('div', _extends({
    'className': _$cn(classNameObj)
  }, getRestProps(this)), vNodes);
}
;