import _inheritsLoose from "@babel/runtime-corejs3/helpers/inheritsLoose";
import { Component, provide } from 'intact-vue-next';
import template from './group.vdt';
import { toggleArray } from '../utils';
import { BUTTON_GROUP } from './constants';
var typeDefs = {
  vertical: Boolean,
  value: null,
  fluid: Boolean,
  checkType: ['none', 'radio', 'checkbox']
};

var defaults = function defaults() {
  return {
    checkType: 'none'
  };
};

export var ButtonGroup = /*#__PURE__*/function (_Component) {
  _inheritsLoose(ButtonGroup, _Component);

  function ButtonGroup() {
    return _Component.apply(this, arguments) || this;
  }

  var _proto = ButtonGroup.prototype;

  _proto.init = function init() {
    provide(BUTTON_GROUP, this);
  };

  _proto.setValue = function setValue(v) {
    var _this$get = this.get(),
        checkType = _this$get.checkType,
        value = _this$get.value;

    if (checkType === 'radio') {
      this.set('value', v);
    } else if (checkType === 'checkbox') {
      value = toggleArray(value, v);
      this.set('value', value);
    }
  };

  return ButtonGroup;
}(Component);
ButtonGroup.template = template;
ButtonGroup.typeDefs = typeDefs;
ButtonGroup.defaults = defaults;