import { Component, ComponentConstructor, TypeDefs } from 'intact-vue-next';
import { Sizes, Colors } from '../types';
export * from './group';
interface ButtonHTMLAttributes {
    autofocus?: boolean;
    form?: string;
    formaction?: string;
    formenctype?: string;
    formmethod?: string;
    formnovalidate?: boolean;
    formtarget?: string;
}
export interface ButtonProps extends ButtonHTMLAttributes {
    type?: Colors | 'none' | 'secondary' | 'link';
    size?: Sizes;
    icon?: boolean;
    circle?: boolean;
    loading?: boolean;
    disabled?: boolean;
    fluid?: boolean;
    htmlType?: 'submit' | 'reset' | 'button';
    tagName?: string | ComponentConstructor;
    value?: any;
    name?: string;
    tabindex?: string | number;
    ghost?: boolean;
}
export interface ButtonEvents {
    click: [MouseEvent];
    mouseup: [MouseEvent];
}
export declare class Button extends Component<ButtonProps, ButtonEvents> {
    static template: import("intact").Template<any>;
    static typeDefs: Required<TypeDefs<Omit<ButtonProps, keyof ButtonHTMLAttributes>>>;
    static defaults: () => Partial<ButtonProps>;
    private buttonGroup;
    private elementRef;
    showLoading(): void;
    hideLoading(): void;
    disable(): void;
    enable(): void;
    private isChecked;
    private onClick;
    private onMouseUp;
}
