import _extends from "@babel/runtime-corejs3/helpers/extends";
import { createUnknownComponentVNode as _$cc, className as _$cn, createElementVNode as _$ce } from 'intact-vue-next';
import { getRestProps } from '../utils';
import { Icon } from '../icon';
import { makeButtonStyles } from './styles';
import { DynamicButton } from './dynamicButton';
export default function ($props, $blocks, $__proto__) {
  var _classNameObj;

  $blocks || ($blocks = {});
  $props || ($props = {});
  var $this = this;

  var _this$get = this.get(),
      type = _this$get.type,
      className = _this$get.className,
      size = _this$get.size,
      icon = _this$get.icon,
      circle = _this$get.circle,
      ref = _this$get.ref,
      key = _this$get.key,
      tabindex = _this$get.tabindex,
      tagName = _this$get.tagName,
      htmlType = _this$get.htmlType,
      fluid = _this$get.fluid,
      children = _this$get.children,
      loading = _this$get.loading,
      disabled = _this$get.disabled,
      name = _this$get.name,
      ghost = _this$get.ghost;

  var checked = this.isChecked();

  var isIcon = function isIcon(child) {
    return child.tag === Icon || child.className && child.className.indexOf('icon') > -1;
  };

  var iconSide; // hack for loading transition of width

  if (!icon && Array.isArray(children)) {
    children.forEach(function (child, index) {
      if (child) {
        // whether the icon is on the left side or right
        if (index === 0) {
          if (isIcon(child)) {
            iconSide = 'left';
          }
        } else if (index === children.length - 1) {
          if (isIcon(child)) {
            iconSide = 'right';
          }
        }
      }
    });
  }

  var classNameObj = (_classNameObj = {
    'k-btn': true
  }, _classNameObj["k-" + type] = type !== 'default', _classNameObj["k-" + size] = size !== 'default', _classNameObj['k-btn-icon'] = icon, _classNameObj[className] = className, _classNameObj['k-circle'] = circle, _classNameObj['k-loading'] = loading, _classNameObj['k-fluid'] = fluid, _classNameObj['k-active'] = checked, _classNameObj['k-disabled'] = disabled || loading, _classNameObj['k-ghost'] = ghost, _classNameObj[makeButtonStyles({
    iconSide: iconSide
  })] = true, _classNameObj);

  var loadingIcon = _$cc(Icon, {
    'className': 'ion-load-c k-icon-loading',
    'size': size
    /*loadingSizeMap[size]*/
    ,
    'key': 'k-loading',
    'rotate': true
  }, 'k-loading');

  var buttonGroup = this.buttonGroup;
  var checkType = buttonGroup ? buttonGroup.get('checkType') : 'none';
  var isCheckType = checkType !== 'none';
  return _$cc(DynamicButton, _extends({
    'className': _$cn(classNameObj),
    'tagName': tagName
  }, getRestProps(this), {
    'ref': this.elementRef,
    'tabindex': disabled || loading ? '-1' : tabindex,
    'ev-click': this.onClick,
    'ev-mouseup': this.onMouseUp,
    'htmlType': htmlType,
    'name': isCheckType ? null : name,
    'children': [loading ? iconSide === 'right' ? [children, loadingIcon] : [loadingIcon, children] : children, isCheckType ? _$ce(64, 'input', null, 1, 'k-button-input', {
      'type': checkType,
      'name': name,
      'checked': checked,
      'tabindex': '-1'
    }) : undefined]
  }), null, this.elementRef);
}
;