import { ThemeValue } from '../../styles/theme';
import '../../styles/global';
declare type TypeStyles = {
    color: ThemeValue<string>;
    bgColor: ThemeValue<string>;
    borderColor: ThemeValue<string>;
    hoverBorderColor: ThemeValue<string>;
    ghostColor: ThemeValue<string>;
};
declare type SizeStyles = {
    fontSize: ThemeValue<string>;
    height: ThemeValue<string>;
    padding: ThemeValue<string>;
};
export declare const types: readonly ["primary", "warning", "danger", "active", "success"];
declare const button: {
    active: TypeStyles;
    secondary: {
        readonly color: string;
        readonly borderColor: string;
        readonly hoverBgColor: string;
        readonly activeBgColor: string;
    };
    link: {
        readonly color: string;
        readonly hoverColor: string;
    };
    group: {
        primary: {
            readonly borderColor: string;
        };
        warning: {
            readonly borderColor: string;
        };
        danger: {
            readonly borderColor: string;
        };
        success: {
            readonly borderColor: string;
        };
    };
} & {
    readonly color: string;
    bgColor: string;
    lineHeight: string;
    readonly padding: string;
    readonly borderColor: string;
    readonly borderRadius: string;
    readonly fontSize: string;
    readonly height: string;
    readonly hoverBorderColor: string;
    readonly hoverColor: string;
    ghost: {
        color: string;
        readonly hoverColor: string;
        borderColor: string;
        readonly hoverBorderColor: string;
    };
    icon: {
        gap: string;
        fontSize: string;
    };
    disabled: {
        readonly color: string;
        readonly bgColor: string;
        readonly borderColor: string;
        readonly ghostBorderColor: string;
    };
} & {
    success: TypeStyles;
    warning: TypeStyles;
    primary: TypeStyles;
    danger: TypeStyles;
    active: TypeStyles;
} & {
    small: SizeStyles;
    large: SizeStyles;
    mini: SizeStyles;
};
export { button };
export declare function makeButtonStyles({ iconSide }: {
    iconSide?: string;
}): string;
export declare function makeButtonGroupStyles(): string;
