import { TypeDefs } from 'intact-vue-next';
import { BaseSelect, BaseSelectProps } from '../select/base';
export interface CascaderProps extends BaseSelectProps {
    data?: CascaderData[];
    trigger?: 'click' | 'hover';
    changeOnSelect?: boolean;
    format?: (labels: string[]) => string;
    loadData?: (data: CascaderData) => CascaderData[];
    filter?: (keywords: string, data: CascaderData) => boolean;
}
export declare type CascaderData = {
    value: any;
    label: string;
    disabled?: boolean;
    loaded?: boolean;
    children?: CascaderData[];
};
export declare class Cascader extends BaseSelect<CascaderProps> {
    static template: import("intact").Template<any>;
    static typeDefs: Required<TypeDefs<CascaderProps>>;
    static defaults: () => Partial<CascaderProps>;
    private value;
    private label;
    private load;
    private filterable;
    private positionObj;
    protected getPlaceholder(): string | number | boolean | import("misstime/dist/utils/types").VNode<any> | import("intact").Children[];
    protected getLabel(): import("intact").Children;
}
