import _valuesInstanceProperty from "@babel/runtime-corejs3/core-js/instance/values";
import _mapInstanceProperty from "@babel/runtime-corejs3/core-js/instance/map";
import _filterInstanceProperty from "@babel/runtime-corejs3/core-js/instance/filter";
import { createUnknownComponentVNode as _$cc, createElementVNode as _$ce, className as _$cn, superCall as _$su, extend as _$ex, EMPTY_OBJ as _$em, map as _$ma } from 'intact-vue-next';
import { Dropdown, DropdownMenu, DropdownItem } from '../dropdown';
import { Icon } from '../icon';
import { _$ } from '../../i18n';
import { makeMenuStyles, makeFilterMenuStyles } from './styles';
var _$tmp0 = {
  'className': 'ion-load-c k-cascader-loading',
  'rotate': true
};
var _$tmp1 = {
  'className': 'k-cascader-arrow ion-ios-arrow-right'
};
export default function ($props, $blocks, $__proto__) {
  var _classNameObj,
      _this = this;

  $blocks || ($blocks = {});
  $props || ($props = {});
  var $this = this;

  var _this$get = this.get(),
      data = _this$get.data,
      trigger = _this$get.trigger,
      filterable = _this$get.filterable;

  var baseMenuStyles = makeMenuStyles();
  var classNameObj = (_classNameObj = {
    'k-cascader-menu': true
  }, _classNameObj[baseMenuStyles] = true, _classNameObj);

  var _this$value = this.value,
      values = _valuesInstanceProperty(_this$value),
      isShowed = _this$value.isShowed,
      isSelected = _this$value.isSelected,
      onSelect = _this$value.onSelect,
      toggleShowedValue = _this$value.toggleShowedValue;

  var Options = function Options(data, level, loaded) {
    if (!data.length) {
      if (!loaded) {
        return _$cc(Icon, _$tmp0);
      } else {
        return _$ce(2, 'div', _$('无数据'), 0, 'k-cascader-empty');
      }
    }

    return _mapInstanceProperty(data).call(data, function (item, index) {
      var value = item.value;
      var showed = isShowed(value, level);
      var selected = isSelected(value, level);
      var children = item.children;

      var Item = function Item() {
        return _$cc(DropdownItem, {
          'disabled': item.disabled,
          'className': _$cn({
            'k-cascader-option': true,
            'k-active': showed,
            'k-selected': selected
          }),
          'ev-select': onSelect.bind(null, value, level),
          'children': [item.label, children ? _$cc(Icon, _$tmp1) : undefined]
        });
      };

      return children ? _$cc(Dropdown, {
        'position': _this.positionObj,
        'of': 'parent',
        'disabled': item.disabled,
        'trigger': trigger,
        'value': showed,
        'ev-$changed:value': toggleShowedValue.bind(null, value, level),
        'ev-show': _this.load.bind(null, item),
        'children': [Item(), _$cc(DropdownMenu, {
          'className': _$cn(classNameObj),
          'children': showed ? Options(children, level + 1, item.loaded) : null
        })]
      }) : Item();
    });
  };

  var _this$filterable = this.filterable,
      filter = _filterInstanceProperty(_this$filterable),
      keywords = _this$filterable.keywords.value,
      selectByFilter = _this$filterable.selectByFilter;

  return _$su.call($this, null, function ($blocks) {
    var _$blocks = {},
        __$blocks = _$ex({}, $blocks);

    return (_$blocks['base-menu'] = function ($super) {
      var _$cn2;

      return !filterable || !keywords ? _$cc(DropdownMenu, {
        'className': _$cn(classNameObj),
        'key': 'common',
        'children': Options(data, 0, true)
      }, 'common') : _$cc(DropdownMenu, {
        'key': 'filter',
        'className': _$cn((_$cn2 = {
          'k-cascader-filter': true
        }, _$cn2[baseMenuStyles] = true, _$cn2[makeFilterMenuStyles()] = true, _$cn2)),
        'children': function () {
          var items = filter();
          if (!items.length) return _$ce(2, 'div', _$('无匹配数据'), 0, 'k-cascader-empty');
          return _$ma(items, function ($value, $key) {
            return _$cc(DropdownItem, {
              'ev-select': selectByFilter.bind(null, $value),
              'disabled': $value.disabled,
              'children': function () {
                // highlight keywords
                var label = _mapInstanceProperty($value).call($value, function (item) {
                  return item.label;
                }).join(' / ');

                var labels = label.split(keywords);
                var length = labels.length;
                return _mapInstanceProperty(labels).call(labels, function (item, index) {
                  var ret = [item];

                  if (index !== length - 1) {
                    ret.push(_$ce(2, 'em', keywords, 0));
                  }

                  return ret;
                });
              }()
            });
          }, $this);
        }()
      }, 'filter');
    }, __$blocks['base-menu'] = function ($super, data) {
      var block = $blocks['base-menu'];

      var callBlock = function callBlock() {
        return _$blocks['base-menu'].call($this, $super, data);
      };

      return block ? block.call($this, callBlock, data) : callBlock();
    }), __$blocks;
  }.call($this, $blocks), $__proto__);
}
;