import _filterInstanceProperty from "@babel/runtime-corejs3/core-js/instance/filter";
import { css } from '@emotion/css';
import { theme } from '../../styles/theme';
import { deepDefaults } from '../../styles/utils';
import '../../styles/global';

var _deepDefaults = deepDefaults(theme, {
  cascader: {
    width: '140px',
    height: '160px',
    loadingGap: '20px',
    arrowGap: '8px',

    get selectedColor() {
      return theme.color.primary;
    },

    get activeBgColor() {
      return theme.color.bg;
    },

    // empty
    empty: {
      padding: "16px",

      get color() {
        return theme.color.placeholder;
      }

    },
    // filter
    filter: {
      get highlightColor() {
        return theme.color.danger;
      },

      minWidth: '300px',
      maxHeight: '200px'
    }
  }
}),
    cascader = _deepDefaults.cascader;

export function makeMenuStyles() {
  return /*#__PURE__*/css("min-width:", cascader.width, "!important;height:", cascader.height, ";.k-cascader-arrow{float:right;height:100%;margin-left:", cascader.arrowGap, ";line-height:inherit;}.k-cascader-loading{display:block;text-align:center;margin-top:", cascader.loadingGap, ";}.k-cascader-empty{padding:", cascader.empty.padding, ";color:", cascader.empty.color, ";text-align:center;}.k-cascader-option{&.k-selected{color:", cascader.selectedColor, ";}&.k-active{background:", cascader.activeBgColor, ";}}");
}
export function makeFilterMenuStyles() {
  return /*#__PURE__*/css("min-width:", _filterInstanceProperty(cascader).minWidth, "!important;height:auto;max-height:", _filterInstanceProperty(cascader).maxHeight, ";em{font-style:normal;color:", _filterInstanceProperty(cascader).highlightColor, ";}");
}