import _filterInstanceProperty from "@babel/runtime-corejs3/core-js/instance/filter";
import _sliceInstanceProperty from "@babel/runtime-corejs3/core-js/instance/slice";
import _mapInstanceProperty from "@babel/runtime-corejs3/core-js/instance/map";
import { useInstance } from 'intact-vue-next';
export function useFilterable(keywords, setValue) {
  var instance = useInstance();

  function filter() {
    var _instance$get = instance.get(),
        data = _instance$get.data,
        filter = _filterInstanceProperty(_instance$get);

    var ret = [];

    var loop = function loop(data, prefix, valid, disabled) {
      if (prefix === void 0) {
        prefix = [];
      }

      if (valid === void 0) {
        valid = false;
      }

      if (disabled === void 0) {
        disabled = false;
      }

      data.forEach(function (item) {
        var _valid = valid || filter(keywords.value, item);

        var _disabled = disabled || item.disabled;

        var _prefix = _sliceInstanceProperty(prefix).call(prefix, 0);

        _prefix.push(item);

        if (item.children) {
          loop(item.children, _prefix, _valid, _disabled);
        } else if (_valid) {
          _prefix.disabled = _disabled;
          ret.push(_prefix);
        }
      });
    };

    loop(data);
    return ret;
  }

  function selectByFilter(data) {
    var value = _mapInstanceProperty(data).call(data, function (item) {
      return item.value;
    });

    setValue(value);
  }

  return {
    filter: filter,
    selectByFilter: selectByFilter,
    keywords: keywords
  };
}