import _includesInstanceProperty from "@babel/runtime-corejs3/core-js/instance/includes";
import { useInstance } from 'intact-vue-next';
import { useBaseLabel } from '../select/useBaseLabel';
export function useLabel() {
  var instance = useInstance();

  function findLabel(data, value) {
    var _instance$get = instance.get(),
        format = _instance$get.format;

    var labels = [];
    var length = value.length;

    var loop = function loop(data) {
      for (var i = 0; i < data.length; i++) {
        var item = data[i];

        if (_includesInstanceProperty(value).call(value, item.value)) {
          labels.push(item.label);

          if (labels.length === length) {
            return;
          }
        }

        var children = item.children;

        if (children) {
          loop(children);
        }
      }
    };

    loop(data);
    return labels.length ? format(labels) : null;
  }

  return useBaseLabel(function () {
    return instance.get('data');
  }, findLabel);
}