import { Component, TypeDefs } from 'intact-vue-next';
import { CommonInputHTMLAttributes } from '../types';
export interface CheckboxProps extends CommonInputHTMLAttributes {
    disabled?: boolean;
    value?: any;
    trueValue?: any;
    falseValue?: any;
    indeterminate?: boolean;
}
export interface CheckboxEvents {
    click: [MouseEvent];
    change: [any, MouseEvent];
}
export declare class Checkbox extends Component<CheckboxProps, CheckboxEvents> {
    static template: import("intact").Template<any>;
    static typeDefs: Required<TypeDefs<Omit<CheckboxProps, keyof CommonInputHTMLAttributes>>>;
    static defaults: () => Partial<CheckboxProps>;
    private inputRef;
    private isChecked;
    private setCheckboxModel;
    private onClick;
    private onKeypress;
}
