import { Component } from 'intact-vue-next';
import { Dayjs } from 'dayjs';
import type { Datepicker } from './index';
import { StateValue } from './basepicker';
import { PanelFlags } from './usePanel';
export interface DatepickerCalendarProps {
    value: StateValue;
    type?: 'date' | 'year' | 'month';
    flag: PanelFlags;
}
export interface DatepickerCalendarEvents {
    change: [Dayjs, PanelFlags];
}
export declare class DatepickerCalendar extends Component<DatepickerCalendarProps, DatepickerCalendarEvents> {
    static template: import("intact").Template<any>;
    static defaults: () => Partial<DatepickerCalendarProps>;
    type: import("../../hooks/useState").State<Required<"month" | "year" | "date" | undefined>>;
    datepicker: Datepicker;
    showDate: {
        date: import("../../hooks/useState").State<Dayjs>;
        getDateLabel: () => {
            value: string;
            onClick(e: import("../../hooks/useDocumentClick").IgnoreClickEvent): void;
        }[];
        prevMonth: () => void;
        nextMonth: () => void;
        prevYear: () => void;
        nextYear: () => void;
        nextTenYears: () => void;
        prevTenYears: () => void;
    };
    status: {
        isActive: (date: Dayjs, type: "month" | "year" | "date" | undefined) => boolean;
        isInRange: (date: Dayjs, type: "month" | "year" | "date" | undefined) => boolean;
        isDisabled: (value: Dayjs, type?: "second" | "month" | "year" | "date") => boolean;
    };
    days: {
        getDays: (now: Dayjs) => {
            isExceed: boolean;
            isActive: boolean;
            isToday: boolean;
            isDisabled: boolean;
            isHover: boolean;
            isInRange: boolean;
            label: number;
            value: Dayjs;
        }[];
        onClick: (value: Dayjs) => void;
    };
    years: {
        getYearRange: () => number[];
        getYearLabel: () => string;
        getYears: (now: Dayjs) => {
            isExceed: boolean;
            isActive: boolean;
            isToday: boolean;
            isDisabled: boolean;
            isHover: boolean;
            isInRange: boolean;
            label: number;
            value: Dayjs;
        }[];
        onClick: (date: Dayjs) => void;
    };
    months: {
        getMonths: (now: Dayjs) => {
            isActive: boolean;
            isToday: boolean;
            isDisabled: boolean;
            isHover: boolean;
            isInRange: boolean;
            label: string;
            value: Dayjs;
        }[];
        onClick: (date: Dayjs) => void;
    };
    triggerChange(value: Dayjs): void;
}
