import _extends from "@babel/runtime-corejs3/helpers/extends";
import _objectWithoutPropertiesLoose from "@babel/runtime-corejs3/helpers/objectWithoutPropertiesLoose";
var _excluded = ["setValue", "value"];
import _sortInstanceProperty from "@babel/runtime-corejs3/core-js/instance/sort";
import { useInstance } from 'intact-vue-next';
import { useValue as useValueBase } from './basepicker';
import { last } from '../utils';
import { PanelTypes } from './usePanel';
export function useValue(formats, disabled, panel) {
  var instance = useInstance();

  var _useValueBase = useValueBase(formats, disabled, panel, function (v) {
    var _instance$get = instance.get(),
        type = _instance$get.type,
        range = _instance$get.range;

    return type !== 'datetime' && (!range || v.length === 2);
  }, function (v) {
    setValue(v, true);
  }, function () {
    var _instance$get2 = instance.get(),
        type = _instance$get2.type;

    return type === 'datetime' ? 'second' : type;
  }),
      setValue = _useValueBase.setValue,
      value = _useValueBase.value,
      rest = _objectWithoutPropertiesLoose(_useValueBase, _excluded);

  function onChangeDate(v, flag) {
    var _instance$get3 = instance.get(),
        multiple = _instance$get3.multiple,
        type = _instance$get3.type,
        range = _instance$get3.range;

    var _value = v;

    if (range) {
      var oldValue = last(value.value);

      if (!oldValue || oldValue.length === 2) {
        _value = [v];
      } else {
        _value = [oldValue[0], v];

        _sortInstanceProperty(_value).call(_value, function (a, b) {
          return a.isAfter(b) ? 1 : -1;
        });
      }
    }

    setValue(_value, false);

    if (type === 'datetime') {
      panel.changePanel(PanelTypes.Time, flag);
    } else if (!multiple && (!range || _value.length === 2)) {
      instance.hide();
    }
  }

  return _extends({
    value: value,
    setValue: setValue,
    onChangeDate: onChangeDate
  }, rest);
}