import { Component, Key } from 'intact-vue-next';
import type { DShape } from './shapes/shape';
import type { DLine } from './shapes/line';
import type { DLayout } from './layouts/layout';
export interface DiagramProps {
}
export interface DiagramEvents {
    labelChanged: [any, string, string];
    selectionChanged: [any[]];
}
export declare class Diagram extends Component<DiagramProps, DiagramEvents> {
    static template: import("intact").Template<any>;
    graph: any;
    cell: any;
    shapes: Map<Key, DShape>;
    private lines;
    private layouts;
    private canvasRef;
    private isCellSelectable;
    private isCellRotatable;
    private isCellMovable;
    private isCellResizable;
    private isCellEditable;
    private isCellConnectable;
    init(): void;
    mounted(): void;
    updated(): void;
    beforeUnmount(): void;
    addShape(shape: DShape): void;
    deleteShape(shape: DShape): void;
    addLine(line: DLine): void;
    deleteLine(line: DLine): void;
    addLayout(layout: DLayout): void;
    deleteLayout(layout: DLayout): void;
    private onSelectionChange;
    private initGraph;
    private draw;
}
