import _inheritsLoose from "@babel/runtime-corejs3/helpers/inheritsLoose";
import _extends from "@babel/runtime-corejs3/helpers/extends";
import { DLayout } from './layout';
import mx from '../mxgraph';
var mxCircleLayout = mx.mxCircleLayout;

var typeDefs = _extends({}, DLayout.typeDefs, {
  x0: [Number, String],
  y0: [Number, String]
});

var defaults = function defaults() {
  return _extends({}, DLayout.defaults(), {
    x0: 0,
    y0: 0
  });
};

export var DCircleLayout = /*#__PURE__*/function (_DLayout) {
  _inheritsLoose(DCircleLayout, _DLayout);

  function DCircleLayout() {
    return _DLayout.apply(this, arguments) || this;
  }

  var _proto = DCircleLayout.prototype;

  _proto.getLayout = function getLayout(graph) {
    var _this$get = this.get(),
        x0 = _this$get.x0,
        y0 = _this$get.y0;

    var layout = new mxCircleLayout(graph); // layout.radius = radius;

    layout.moveCircle = true;
    layout.x0 = x0;
    layout.y0 = y0;
    layout.disableEdgeStyle = false;
    return layout;
  };

  _proto.execute = function execute(layout, cells, parent, graph) {
    if (!cells.length) return;
    var tmp = parent.cell;
    layout.execute(tmp); // if (graph.getModel().isVertex(tmp)) {
    // graph.updateGroupBounds([tmp], graph.gridSize * 2, true);
    // }
  };

  return DCircleLayout;
}(DLayout);
DCircleLayout.displayName = 'DCircleLayout';
DCircleLayout.typeDefs = typeDefs;
DCircleLayout.defaults = defaults;