import { Component, TypeDefs } from 'intact-vue-next';
import { DBase } from '../shapes/base';
import type { DShape } from '../shapes/shape';
import type { Diagram } from '../diagram';
import type { Cell } from '../shapes/base';
export interface DLayoutProps {
    left?: number | string;
    top?: number | string;
}
export declare abstract class DLayout<P extends DLayoutProps = DLayoutProps> extends Component<P> {
    static template: (this: DLayout) => import("intact").VNode<string>;
    static typeDefs: Required<TypeDefs<DLayoutProps>>;
    static defaults: () => Partial<DLayoutProps>;
    private diagram;
    private shapes;
    private shape;
    init(): void;
    mounted(): void;
    beforeUnmount(): void;
    addShape(shape: DBase): void;
    deleteShape(shape: DBase): void;
    draw(): void;
    protected abstract getLayout(graph: any): any;
    protected execute(layout: any, cells: Cell[], parent: DShape | Diagram, graph: any): void;
}
