import _inheritsLoose from "@babel/runtime-corejs3/helpers/inheritsLoose";
import _extends from "@babel/runtime-corejs3/helpers/extends";
import { DLayout } from './layout';
import mx from '../mxgraph';
var mxFastOrganicLayout = mx.mxFastOrganicLayout;

var typeDefs = _extends({}, DLayout.typeDefs, {
  forceConstant: [Number, String]
});

var defaults = function defaults() {
  return _extends({}, DLayout.defaults(), {
    // The force constant by which the attractive forces are divided and the replusive forces are multiple by the square of.  The value equates to the average radius there is of free space around each node. 
    forceConstant: 50
  });
};

export var DOrganicLayout = /*#__PURE__*/function (_DLayout) {
  _inheritsLoose(DOrganicLayout, _DLayout);

  function DOrganicLayout() {
    return _DLayout.apply(this, arguments) || this;
  }

  var _proto = DOrganicLayout.prototype;

  _proto.getLayout = function getLayout(graph) {
    var _this$get = this.get(),
        forceConstant = _this$get.forceConstant;

    var layout = new mxFastOrganicLayout(graph);
    layout.forceConstant = +forceConstant;
    layout.disableEdgeStyle = false;
    return layout;
  };

  _proto.execute = function execute(layout, cells, parent, graph) {
    if (!cells.length) return;
    var tmp = parent.cell;
    layout.execute(tmp); // if (graph.getModel().isVertex(tmp)) {
    // graph.updateGroupBounds([tmp], graph.gridSize * 2, true);
    // }
  };

  return DOrganicLayout;
}(DLayout);
DOrganicLayout.displayName = 'DOrganicLayout';
DOrganicLayout.typeDefs = typeDefs;
DOrganicLayout.defaults = defaults;