import _inheritsLoose from "@babel/runtime-corejs3/helpers/inheritsLoose";
import _extends from "@babel/runtime-corejs3/helpers/extends";
import { DLayout } from './layout';
import mx from '../mxgraph';
var mxPartitionLayout = mx.mxPartitionLayout;

var typeDefs = _extends({}, DLayout.typeDefs, {
  type: ['horizontal', 'vertical'],
  spacing: [Number, String],
  border: [Number, String],
  resizeVertices: Boolean
});

var defaults = function defaults() {
  return _extends({}, DLayout.defaults(), {
    type: 'horizontal',
    // Integer that specifies the absolute spacing in pixels between the children. 
    spacing: 0,
    // Integer that specifies the absolute inset in pixels for the parent that contains the children.
    border: 0,
    // Boolean that specifies if vertices should be resized.
    resizeVertices: true
  });
};

export var DPartitionLayout = /*#__PURE__*/function (_DLayout) {
  _inheritsLoose(DPartitionLayout, _DLayout);

  function DPartitionLayout() {
    return _DLayout.apply(this, arguments) || this;
  }

  var _proto = DPartitionLayout.prototype;

  _proto.getLayout = function getLayout(graph) {
    var _this$get = this.get(),
        type = _this$get.type,
        spacing = _this$get.spacing,
        border = _this$get.border,
        resizeVertices = _this$get.resizeVertices;

    var layout = new mxPartitionLayout(graph, type === 'horizontal');
    layout.spacing = +spacing;
    layout.border = +border;
    layout.resizeVertices = resizeVertices;
    return layout;
  };

  return DPartitionLayout;
}(DLayout);
DPartitionLayout.displayName = 'DPartitionLayout';
DPartitionLayout.typeDefs = typeDefs;
DPartitionLayout.defaults = defaults;