import _inheritsLoose from "@babel/runtime-corejs3/helpers/inheritsLoose";
import _extends from "@babel/runtime-corejs3/helpers/extends";
import { DLayout } from './layout';
import mx from '../mxgraph';
var mxRadialTreeLayout = mx.mxRadialTreeLayout;

var typeDefs = _extends({}, DLayout.typeDefs, {
  levelDistance: [Number, String],
  nodeDistance: [Number, String],
  rootx: [Number, String],
  rooty: [Number, String]
});

var defaults = function defaults() {
  return _extends({}, DLayout.defaults(), {
    levelDistance: 60,
    nodeDistance: 16,
    rootx: 0,
    rooty: 0
  });
};

export var DRadialLayout = /*#__PURE__*/function (_DLayout) {
  _inheritsLoose(DRadialLayout, _DLayout);

  function DRadialLayout() {
    return _DLayout.apply(this, arguments) || this;
  }

  var _proto = DRadialLayout.prototype;

  _proto.getLayout = function getLayout(graph) {
    var _this$get = this.get(),
        levelDistance = _this$get.levelDistance,
        nodeDistance = _this$get.nodeDistance;

    var layout = new mxRadialTreeLayout(graph);
    layout.autoRadius = true;
    layout.nodeDistance = +nodeDistance;
    layout.levelDistance = +levelDistance; // layout.useBoundingBox = false;

    layout.edgeRouting = false;
    return layout;
  };

  _proto.execute = function execute(layout, cells, parent, graph) {
    if (!cells.length) return;
    var roots = graph.findTreeRoots(parent.cell);
    var tmp = cells[0];

    if (roots && roots.length) {
      tmp = roots[0];
    }

    var _this$get2 = this.get(),
        rootx = _this$get2.rootx,
        rooty = _this$get2.rooty;

    var geo = tmp.getGeometry().clone();
    if (rootx != null) geo.x = +rootx;
    if (rooty != null) geo.y = +rooty;
    graph.model.setGeometry(tmp, geo);
    layout.execute(parent.cell, tmp);
  };

  return DRadialLayout;
}(DLayout);
DRadialLayout.displayName = 'DRadialLayout';
DRadialLayout.typeDefs = typeDefs;
DRadialLayout.defaults = defaults;