import _inheritsLoose from "@babel/runtime-corejs3/helpers/inheritsLoose";
import _extends from "@babel/runtime-corejs3/helpers/extends";
import _fillInstanceProperty from "@babel/runtime-corejs3/core-js/instance/fill";
import { DLayout } from './layout';
import mx from '../mxgraph';
var mxStackLayout = mx.mxStackLayout;

var typeDefs = _extends({}, DLayout.typeDefs, {
  type: ['horizontal', 'vertical'],
  spacing: [Number, String],
  wrap: [Number, String],
  fill: Boolean,
  border: [Number, String],
  resizeParent: Boolean
});

var defaults = function defaults() {
  return _extends({}, DLayout.defaults(), {
    type: 'horizontal',
    // Specifies the spacing between the cells.
    spacing: 0,
    // Value at which a new column or row should be created.
    wrap: undefined,
    // Boolean indicating if dimension should be changed to fill out the parent cell.
    fill: false,
    // Border to be added if fill is true. 
    border: 0,
    // If the parent should be resized to match the width/height of the stack.
    resizeParent: false
  });
};

export var DStackLayout = /*#__PURE__*/function (_DLayout) {
  _inheritsLoose(DStackLayout, _DLayout);

  function DStackLayout() {
    return _DLayout.apply(this, arguments) || this;
  }

  var _proto = DStackLayout.prototype;

  _proto.getLayout = function getLayout(graph) {
    var _this$get = this.get(),
        type = _this$get.type,
        spacing = _this$get.spacing,
        wrap = _this$get.wrap,
        fill = _fillInstanceProperty(_this$get),
        border = _this$get.border,
        resizeParent = _this$get.resizeParent;

    var layout = new mxStackLayout(graph, type === 'horizontal');
    layout.spacing = +spacing;
    layout.wrap = wrap ? +wrap : null;
    layout.fill = fill;
    layout.border = +border;
    layout.resizeParent = resizeParent;
    return layout;
  };

  return DStackLayout;
}(DLayout);
DStackLayout.displayName = 'DStackLayout';
DStackLayout.typeDefs = typeDefs;
DStackLayout.defaults = defaults;