import { TypeDefs } from 'intact-vue-next';
import { DLayout, DLayoutProps } from './layout';
import type { Cell } from '../shapes/base';
import type { DShape } from '../shapes/shape';
import type { Diagram } from '../diagram';
export interface DTreeLayoutProps extends DLayoutProps {
    type?: 'horizontal' | 'vertical';
    levelDistance?: string | number;
    nodeDistance?: string | number;
    resizeParent?: boolean;
    groupPadding?: string | number;
}
export declare class DTreeLayout extends DLayout<DTreeLayoutProps> {
    static displayName: string;
    static typeDefs: Required<TypeDefs<DTreeLayoutProps>>;
    static defaults: () => Partial<DTreeLayoutProps>;
    protected getLayout(graph: any): any;
    protected execute(layout: any, cells: Cell[], parent: DShape | Diagram, graph: any): void;
}
