import _inheritsLoose from "@babel/runtime-corejs3/helpers/inheritsLoose";
import _extends from "@babel/runtime-corejs3/helpers/extends";
import { DLayout } from './layout';
import mx from '../mxgraph';
var mxCompactTreeLayout = mx.mxCompactTreeLayout;

var typeDefs = _extends({}, DLayout.typeDefs, {
  type: ['horizontal', 'vertical'],
  levelDistance: [Number, String],
  nodeDistance: [Number, String],
  resizeParent: Boolean,
  groupPadding: [Number, String]
});

var defaults = function defaults() {
  return _extends({}, DLayout.defaults(), {
    type: 'horizontal',
    levelDistance: 30,
    nodeDistance: 16,
    // If the parents should be resized to match the width/height of the children. 
    resizeParent: true,
    // Padding added to resized parents.
    groupPadding: 0
  });
};

export var DTreeLayout = /*#__PURE__*/function (_DLayout) {
  _inheritsLoose(DTreeLayout, _DLayout);

  function DTreeLayout() {
    return _DLayout.apply(this, arguments) || this;
  }

  var _proto = DTreeLayout.prototype;

  _proto.getLayout = function getLayout(graph) {
    var _this$get = this.get(),
        type = _this$get.type,
        levelDistance = _this$get.levelDistance,
        nodeDistance = _this$get.nodeDistance,
        resizeParent = _this$get.resizeParent,
        groupPadding = _this$get.groupPadding;

    var layout = new mxCompactTreeLayout(graph, type === 'horizontal');
    layout.nodeDistance = +nodeDistance;
    layout.groupPadding = +groupPadding; // layout.moveTree = true;

    layout.maintainParentLocation = true;
    layout.resizeParent = resizeParent;
    layout.levelDistance = +levelDistance; // layout.useBoundingBox = false;

    layout.edgeRouting = false;
    return layout;
  };

  _proto.execute = function execute(layout, cells, parent, graph) {
    if (!cells.length) return;
    var roots = graph.findTreeRoots(parent.cell);
    var tmp = cells[0];

    if (roots && roots.length) {
      tmp = roots[0];
    }

    layout.execute(parent.cell, tmp); // tmp = graph.getModel().getParent(tmp);
    // if (graph.getModel().isVertex(tmp)) {
    // graph.updateGroupBounds([tmp], graph.gridSize * 2, true);
    // }
  };

  return DTreeLayout;
}(DLayout);
DTreeLayout.displayName = 'DTreeLayout';
DTreeLayout.typeDefs = typeDefs;
DTreeLayout.defaults = defaults;