import _extends from "@babel/runtime-corejs3/helpers/extends";
import _inheritsLoose from "@babel/runtime-corejs3/helpers/inheritsLoose";
import { DShape } from './shape';
var shapes = {
  Diamond: {
    width: 80,
    height: 80,
    stylesheet: 'rhombus;whiteSpace=wrap;html=1;'
  },
  Triangle: {
    width: 60,
    height: 80,
    stylesheet: 'triangle;whiteSpace=wrap;html=1;'
  },
  Cylinder: {
    width: 60,
    height: 80,
    stylesheet: 'shape=cylinder;whiteSpace=wrap;html=1;boundedLbl=1;backgroundOutline=1;'
  },
  Cloud: {
    width: 120,
    height: 80,
    stylesheet: 'ellipse;shape=cloud;whiteSpace=wrap;html=1;'
  }
};
var components = {};

var _loop = function _loop(key) {
  var _class, _temp;

  var value = shapes[key];
  components[key] = (_temp = _class = /*#__PURE__*/function (_DShape) {
    _inheritsLoose(_class, _DShape);

    function _class() {
      return _DShape.apply(this, arguments) || this;
    }

    _class.defaults = function defaults() {
      return _extends({}, DShape.defaults(), {
        width: value.width,
        height: value.height
      });
    };

    var _proto = _class.prototype;

    _proto.getStylesheet = function getStylesheet() {
      return value.stylesheet;
    };

    return _class;
  }(DShape), _class.displayName = "D" + key, _temp);
};

for (var key in shapes) {
  _loop(key);
}

export default components;