import { TypeDefs } from 'intact-vue-next';
import { DShape, DShapeProps } from './shape';
export interface DImageProps extends DShapeProps {
    src?: string;
}
export declare class DImage extends DShape<DImageProps> {
    static displayName: string;
    static typeDefs: Required<TypeDefs<DImageProps>>;
    static defaults(): {
        width: number;
        height: number;
        src: string;
        left?: string | number | undefined;
        top?: string | number | undefined;
        movable?: boolean | undefined;
        selectable?: boolean | undefined;
        resizable?: boolean | undefined;
        rotatable?: boolean | undefined;
        editable?: boolean | undefined;
        connectable?: boolean | undefined;
        strokeStyle?: "dashed" | "dotted" | "solid" | undefined;
        label?: string | number | undefined;
        style?: Record<string, string | number> | undefined;
        data?: any;
    };
    getStylesheet(): string;
}
