import { TypeDefs, Key } from 'intact-vue-next';
import { DBase, DBaseProps } from './base';
export interface DLineProps extends DBaseProps {
    type?: 'rounded' | 'sharp' | 'curved' | 'straight';
    startArrow?: Arrow;
    endArrow?: Arrow;
    startPoint?: Point;
    endPoint?: Point;
    exit?: Point;
    entry?: Point;
    from?: Key;
    to?: Key;
}
declare type Arrow = 'none' | 'classic' | 'classicThin' | 'block' | 'blockThin' | 'open' | 'openThin' | 'oval' | 'diamond' | 'diamondThin';
declare type Point = [number, number];
export declare class DLine extends DBase<DLineProps> {
    static template: (this: DLine) => import("intact").VNode<"dline">;
    static typeDefs: Required<TypeDefs<DLineProps>>;
    static defaults: () => Partial<DLineProps>;
    protected startDraw(): void;
    private setTerminal;
    protected addToDigram(): void;
    protected deleteFromDiagram(): void;
    protected getStylesheet(): string;
    protected getGeometry(): any;
    protected genStyles(): {
        dashed?: number | null | undefined;
        dashPattern?: string | null | undefined;
        edgeStyle?: string | undefined;
        rounded?: number | undefined;
        curved?: number | null | undefined;
        noEdgeStyle?: null | undefined;
        exitX?: number | undefined;
        exitY?: number | undefined;
        perimeter?: number | undefined;
        entryX?: number | undefined;
        entryY?: number | undefined;
    };
    protected updateProps(model: any, lastProps: DLineProps, nextProps: DLineProps): void;
    private genStylesForExitAndEntry;
    private genStylesForType;
}
export {};
