import { TypeDefs } from 'intact-vue-next';
import { DBase, DBaseProps } from './base';
export interface DShapeProps extends DBaseProps {
    left?: string | number;
    top?: string | number;
    width?: string | number;
    height?: string | number;
    movable?: boolean;
    selectable?: boolean;
    resizable?: boolean;
    rotatable?: boolean;
    editable?: boolean;
    connectable?: boolean;
}
export declare abstract class DShape<P extends DShapeProps = DShapeProps> extends DBase<P> {
    static template: (this: DShape) => import("intact").VNode<string>;
    static typeDefs: Required<TypeDefs<DShapeProps>>;
    static defaults: () => Partial<DShapeProps>;
    private wrapperRef;
    private hasElement;
    private children;
    private parent;
    init(): void;
    updated(): void;
    beforeUnmount(): void;
    protected startDraw(): void;
    protected addToDigram(): void;
    protected deleteFromDiagram(): void;
    protected getGeometry(): any;
    protected getValue(): string | HTMLDivElement | null;
    protected setStyle(): void;
}
