import { Component, TypeDefs } from 'intact-vue-next';
import { Sizes } from '../../styles/utils';
import { Container } from '../portal';
import { SHOW, HIDE } from './constants';
export interface BaseDialogProps {
    title?: string;
    value?: boolean;
    size?: Sizes;
    loading?: boolean;
    disabledOk?: boolean;
    okText?: string;
    cancelText?: string;
    ok?: () => void;
    cancel?: () => void;
    container?: Container;
    hideClose?: boolean;
    overlay?: boolean;
    closable?: boolean;
    terminate?: () => void;
    escClosable?: boolean;
    width?: string | number;
    mode?: 'destroy' | 'hide';
}
export interface BaseDialogEvents {
    [SHOW]: [];
    [HIDE]: [];
    ok: [];
    cancel: [];
    terminate: [];
}
export interface BaseDialogBlocks {
    content: null;
    header: null;
    body: null;
    footerWrapper: null;
    footer: null;
}
export declare class BaseDialog<T extends BaseDialogProps = BaseDialogProps, E extends BaseDialogEvents = BaseDialogEvents, B extends BaseDialogBlocks = BaseDialogBlocks> extends Component<T, E, B> {
    static template: import("intact").Template<any>;
    static typeDefs: Required<TypeDefs<BaseDialogProps>>;
    static defaults: () => Partial<BaseDialogProps>;
    dialogRef: import("intact").RefObject<HTMLDivElement>;
    useAsComponent: boolean;
    private overlayRef;
    private drag;
    private position;
    init(): void;
    show(props?: T): void;
    close(): void;
    showLoading(): void;
    hideLoading(): void;
    disableOk(): void;
    enableOk(): void;
    /**
     * @brief
     * only be called by self when user clicks close button,
     * presses ESC or clicks overlay
     */
    terminate(): void;
    ok(): void;
    cancel(): void;
    private btnCallback;
    private onClickWrapper;
}
