import { useInstance, onUnmounted } from 'intact-vue-next';
import { SHOW, HIDE } from './constants'; // only close the top dialog when press ESC

var dialogs = [];

var escClose = function escClose(e) {
  var dialog = dialogs[dialogs.length - 1];

  if (e.keyCode === 27 && dialog.get('escClosable')) {
    dialog.terminate();
  }
};

export function useEscClosable() {
  var instance = useInstance();
  instance.on(SHOW, function () {
    if (!dialogs.length) {
      document.addEventListener('keydown', escClose);
    }

    dialogs.push(instance);
  });

  function onHide() {
    var dialog = dialogs.pop();

    if (process.env.NODE_ENV !== 'production') {
      if (dialog !== instance) {
        throw new Error('The dialog has handled hide callback. It is a bug of KPC');
      }
    }

    if (!dialogs.length) {
      document.removeEventListener('keydown', escClose);
    }
  }

  instance.on(HIDE, onHide);
  onUnmounted(function () {
    if (instance.get('value')) {
      onHide();
    }
  });
}