import { Component, TypeDefs, VNode } from 'intact-vue-next';
import { Options, Feedback } from '../position';
import { Portal, PortalProps } from '../portal';
import { FeedbackCallback } from './usePosition';
export declare type Position = Options;
export declare const DROPDOWN = "Dropdown";
export declare const ROOT_DROPDOWN = "RootDropdown";
export interface DropdownProps {
    trigger?: 'hover' | 'click' | 'contextmenu';
    disabled?: boolean;
    value?: boolean;
    position?: Position | 'left' | 'bottom' | 'right' | 'top';
    of?: 'self' | 'parent' | Event;
    container?: PortalProps['container'];
}
export interface DropdownEvents {
    shouldFocus: [];
    show: [];
    hide: [];
    mouseenter: [MouseEvent];
    mouseleave: [MouseEvent];
    positioned: [Feedback];
}
export interface DropdownBlocks {
}
export declare const typeDefs: Required<TypeDefs<DropdownProps>>;
export declare const defaults: () => Partial<DropdownProps>;
export declare class Dropdown<T extends DropdownProps = DropdownProps, E extends DropdownEvents = DropdownEvents, B extends DropdownBlocks = DropdownBlocks> extends Component<T, E, B> {
    static $doubleVNodes: boolean;
    static typeDefs: Required<TypeDefs<DropdownProps>>;
    static defaults: () => Partial<DropdownProps>;
    static template: (this: Dropdown) => (VNode<import("intact").VNodeTag> | VNode<typeof Portal>)[];
    menuVNode: VNode | null;
    dropdown: Dropdown | null;
    rootDropdown: Dropdown | null;
    showedDropdown: Dropdown | null;
    positionHook: {
        handle: (callback: FeedbackCallback) => void;
        positioned: {
            value: boolean;
        };
    };
    private timer;
    private triggerProps;
    init(): void;
    show(shouldFocus?: boolean): void;
    hide(immediately?: boolean): void;
    focusFirst(): void;
    position(callback?: FeedbackCallback): void;
    private onEnter;
    private onContextMenu;
    private onLeave;
    private callOriginalCallback;
    private normalizeTriggerProps;
}
