import { DropdownItem } from './item';
interface ItemEvents {
    onFocusin: () => void;
    onFocusout: () => void;
    onShowMenu: () => void;
    onHideMenu: () => void;
    onSelect: () => void;
}
export declare enum Direction {
    Up = 0,
    Down = 1
}
export declare type MenuKeyboardMethods = {
    reset: () => void;
    focus: (item: DropdownItem) => void;
};
export declare function useMenuKeyboard(): readonly [readonly [() => void, () => void, (v: boolean) => boolean], (index: number, direction?: Direction | undefined) => void, () => void];
export declare function useItemKeyboard(itemEvents: Omit<ItemEvents, 'onFocusin' | 'onFocusout'>): {
    onMouseEnter(e: MouseEvent): void;
    onMouseLeave(e: MouseEvent): void;
    isFocus: import("../../hooks/useState").State<boolean>;
};
export {};
