import { Component, TypeDefs } from 'intact-vue-next';
export interface EditableProps {
    editing?: boolean;
    value?: string | number;
    required?: boolean;
    validate?: Function | string | RegExp;
    disabled?: boolean;
    tip?: string | number;
    trim?: boolean;
    invalid?: boolean;
}
export interface EditableEvents {
    error: [string | number];
    change: [string, string | number | undefined];
}
export declare class Editable extends Component<EditableProps, EditableEvents> {
    static template: import("intact").Template<any>;
    static typeDefs: Required<TypeDefs<EditableProps>>;
    static defaults: () => Partial<EditableProps>;
    private inputRef;
    private edit;
    private onBlur;
    private onKeydown;
    private setValue;
}
