import { Component, TypeDefs } from 'intact-vue-next';
import type { FormItem } from './item';
interface FormHTMLAttributes {
    acceptcharset?: string;
    autocomplete?: string;
    name?: string;
    rel?: string;
    action?: string;
    enctype?: string;
    method?: 'post' | 'get' | 'dialog';
    novalidate?: boolean;
    target?: string;
}
export interface FormProps extends FormHTMLAttributes {
    labelWidth?: string | number;
    layout?: 'horizontal' | 'vertical' | 'inline';
    starOnRequired?: boolean;
    size?: 'default' | 'small' | 'mini';
}
export interface FormEvents {
    submit: [Event];
}
export declare const FORM = "Form";
export declare const RECORD_KEY = "FormRecord";
export declare class Form extends Component<FormProps, FormEvents> {
    static template: import("intact").Template<any>;
    static typeDefs: Required<TypeDefs<Omit<FormProps, keyof FormHTMLAttributes>>>;
    static defaults: () => Partial<FormProps>;
    static addMethod: (name: string, method: import("./methods").Method, message?: import("./methods").Message | undefined, className?: import("./methods").ClassName | undefined) => void;
    private items;
    init(): void;
    validate(): Promise<boolean>;
    getFirstInvalidFormItem(): FormItem | undefined;
    submit(e: Event): void;
    reset(): void;
    private onSubmit;
}
export {};
