import { Component, TypeDefs } from 'intact-vue-next';
import { messages, classNames } from './methods';
export interface FormItemProps {
    value?: any;
    rules?: Rules;
    messages?: typeof messages;
    classNames?: typeof classNames;
    errorClassName?: string;
    label?: string;
    htmlFor?: string;
    hideLabel?: boolean;
    fluid?: boolean;
}
export interface FormItemEvents {
    change: [Event];
    focusout: [FocusEvent];
}
export interface FormItemBlocks {
    label: null;
    content: null;
    append: null;
}
export declare type Rules = Record<string, any>;
export declare class FormItem extends Component<FormItemProps, FormItemEvents, FormItemBlocks> {
    static template: import("intact").Template<any>;
    static typeDefs: Required<TypeDefs<FormItemProps>>;
    private form;
    private errorRef;
    private error;
    private dirty;
    private validateHook;
    init(): void;
    validate(): boolean | (Promise<boolean> & {
        cancelled: boolean;
    });
    isValid(): boolean;
    reset(): void;
}
