export declare type Breakpoint = 'xxl' | 'xl' | 'lg' | 'md' | 'sm' | 'xs';
export declare type PrimitiveValue = string | number;
export declare type BreakpointValue = {
    [key in Breakpoint]: PrimitiveValue;
};
export declare type Value = PrimitiveValue | BreakpointValue;
export declare type BreakpointPropsValues<T extends string> = {
    [key in T]?: PrimitiveValue;
};
export declare type BreakpointValues<T extends string> = Record<Breakpoint, PrimitiveValue | null | undefined | BreakpointPropsValues<T>>;
export declare const Value: (ObjectConstructor | StringConstructor | NumberConstructor)[];
export declare const PrimitiveValue: (StringConstructor | NumberConstructor)[];
export declare const responsiveMap: Record<Breakpoint, string>;
export declare const breakpoints: Breakpoint[];
