function _EMOTION_STRINGIFIED_CSS_ERROR__() { return "You have tried to stringify object returned from `css` function. It isn't supposed to be used directly (e.g. as value of the `className` prop), but rather handed to emotion so it can handle it (e.g. as value of `css` prop)."; }

import { css } from '@emotion/css';
import { theme } from '../../styles/theme';
import { deepDefaults } from '../../styles/utils';
import '../../styles/global';
import { breakpoints, responsiveMap } from './constants';

var _deepDefaults = deepDefaults(theme, {
  grid: {}
}),
    grid = _deepDefaults.grid;

export function makeRowStyles() {
  return /*#__PURE__*/css(process.env.NODE_ENV === "production" ? {
    name: "1d2b9xj",
    styles: "position:relative;display:flex;flex-wrap:wrap;&.k-justify-start{justify-content:flex-start;}&.k-justify-end{justify-content:flex-end;}&.k-justify-center{justify-content:center;}&.k-justify-between{justify-content:space-between;}&.k-justify-around{justify-content:space-around;}&.k-justify-evenly{justify-content:space-evenly;}&.k-align-top{align-items:flex-start;}&.k-align-bottom{align-items:flex-end;}&.k-align-middle{align-items:center;}&.k-align-stretch{align-items:stretch;}&.k-align-baseline{align-items:baseline;}"
  } : {
    name: "1d2b9xj",
    styles: "position:relative;display:flex;flex-wrap:wrap;&.k-justify-start{justify-content:flex-start;}&.k-justify-end{justify-content:flex-end;}&.k-justify-center{justify-content:center;}&.k-justify-between{justify-content:space-between;}&.k-justify-around{justify-content:space-around;}&.k-justify-evenly{justify-content:space-evenly;}&.k-align-top{align-items:flex-start;}&.k-align-bottom{align-items:flex-end;}&.k-align-middle{align-items:center;}&.k-align-stretch{align-items:stretch;}&.k-align-baseline{align-items:baseline;}",
    toString: _EMOTION_STRINGIFIED_CSS_ERROR__
  });
}
var colsStyles = makeBreakpointsCols();
export function makeColStyles() {
  return /*#__PURE__*/css("position:relative;width:100%;", colsStyles, ";");
}

function makeBreakpointsCols() {
  var styles = [];
  styles.push(makeCols(''));

  for (var i = breakpoints.length - 1; i >= 0; i--) {
    var breakpoint = breakpoints[i];
    if (breakpoint === 'xs') continue;
    styles.push("@media " + responsiveMap[breakpoint] + " {");
    styles.push(makeCols("-" + breakpoint));
    styles.push('}');
  }

  return styles.join('');
}

function makeCols(prefix) {
  var colsStyles = [];

  for (var i = 0; i < 24; i++) {
    var percentage = String(i / 24 * 100) + '%';
    colsStyles.push("\n            &.k" + prefix + "-" + i + " {\n                width: " + percentage + ";\n            }\n            &.k" + prefix + "-offset-" + i + " {\n                margin-left: " + percentage + ";\n            }\n            &.k" + prefix + "-order-" + i + " {\n                order: " + i + ";\n            }\n            &.k" + prefix + "-push-" + i + " {\n                left: " + percentage + ";\n            }\n            &.k" + prefix + "-pull-" + i + " {\n                right: " + percentage + ";\n            }\n        ");
  }

  return colsStyles.join('');
}