import _mapInstanceProperty from "@babel/runtime-corejs3/core-js/instance/map";
import { css } from '@emotion/css';
import { theme } from '../../styles/theme';
import { deepDefaults, palette } from '../../styles/utils';
import { rotate } from '../../styles/keyframes';
import '../../styles/fonts/iconfont';
import '../../styles/fonts/ionicons';
import '../../styles/global';
var iconStyles = {
  fontSize: {
    default: '16px',
    large: '22px',
    small: '14px',
    mini: '12px'
  }
};

var _deepDefaults = deepDefaults(theme, {
  icon: iconStyles
}),
    icon = _deepDefaults.icon;

export var colors = ['primary', 'warning', 'danger', 'success'];
export var sizes = ['large', 'small', 'mini'];
export default function makeStyles(color) {
  return /*#__PURE__*/css("font-size:", icon.fontSize.default, ";line-height:1;", _mapInstanceProperty(sizes).call(sizes, function (size) {
    return /*#__PURE__*/css("&.k-", size, "{font-size:", icon.fontSize[size], ";}");
  }), " ", _mapInstanceProperty(colors).call(colors, function (color) {
    var _color = theme.color[color];
    return /*#__PURE__*/css("&.k-", color, "{color:", _color, ";&.k-hoverable:hover{color:", palette(_color, -2), ";}}");
  }), " &.k-rotate:before{animation:", rotate, " 1s infinite linear;}&:before{font-size:inherit;}&.k-hoverable{cursor:pointer;transition:color ", theme.transition, ";", color && "\n                &:hover {\n                    color: " + palette(color, -2) + " !important;\n                }\n            ", ";&:hover{color:", theme.color.primary, ";}}");
}