import { Component, TypeDefs } from 'intact-vue-next';
import { Sizes } from '../../styles/utils';
import { CommonInputHTMLAttributes } from '../types';
export * from './search';
interface InputHTMLAttributes extends CommonInputHTMLAttributes {
    pattern?: string;
    dirname?: string;
    datalist?: string;
    cols?: number;
    wrap?: 'hard' | 'soft';
}
export interface InputProps extends InputHTMLAttributes {
    type?: 'text' | 'textarea';
    value?: string | number;
    defaultValue?: string | number;
    placeholder?: string;
    readonly?: boolean;
    clearable?: boolean;
    disabled?: boolean;
    size?: Sizes;
    rows?: string | number;
    autoWidth?: boolean;
    fluid?: boolean;
    width?: number | string;
    stackClearIcon?: boolean;
    frozenOnInput?: boolean;
}
export interface InputEvents {
    clear: [MouseEvent];
    focus: [FocusEvent];
    blur: [FocusEvent];
    input: [InputEvent];
}
export interface InputBlocks {
    prepend: null;
    prefix: null;
    suffix: null;
    append: null;
}
export declare class Input extends Component<InputProps, InputEvents, InputBlocks> {
    static template: import("intact").Template<any>;
    static typeDefs: Required<TypeDefs<Omit<InputProps, keyof InputHTMLAttributes>>>;
    static defaults: () => Partial<InputProps>;
    private inputRef;
    private autoWidth;
    private frozen;
    focus(): void;
    blur(): void;
    select(): void;
    private clear;
}
