import _inheritsLoose from "@babel/runtime-corejs3/helpers/inheritsLoose";
import _concatInstanceProperty from "@babel/runtime-corejs3/core-js/instance/concat";
import { __decorate } from "tslib";
import { Component, createRef } from 'intact-vue-next';
import { sizes } from '../../styles/utils';
import template from './index.vdt';
import { bind } from '../utils';
import { useAutoWidth } from './useAutoWidth';
import { useFrozen } from './useFrozen';
export * from './search';
var typeDefs = {
  type: String,
  value: [String, Number],
  defaultValue: [String, Number],
  placeholder: String,
  readonly: Boolean,
  clearable: Boolean,
  disabled: Boolean,
  size: sizes,
  rows: [String, Number],
  autoWidth: Boolean,
  fluid: Boolean,
  width: [Number, String],
  stackClearIcon: Boolean,
  frozenOnInput: Boolean
};

var defaults = function defaults() {
  return {
    type: 'text',
    size: 'default',
    rows: 2
  };
};

export var Input = /*#__PURE__*/function (_Component) {
  _inheritsLoose(Input, _Component);

  function Input() {
    var _context;

    var _this;

    for (var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    _this = _Component.call.apply(_Component, _concatInstanceProperty(_context = [this]).call(_context, args)) || this;
    _this.inputRef = createRef();
    _this.autoWidth = useAutoWidth();
    _this.frozen = useFrozen();
    return _this;
  }

  var _proto = Input.prototype;

  _proto.focus = function focus() {
    this.inputRef.value.focus();
  };

  _proto.blur = function blur() {
    this.inputRef.value.blur();
  };

  _proto.select = function select() {
    var input = this.inputRef.value;

    if (input.select) {
      input.select();
    } else if (input.setSelectionRange) {
      // mobile safari
      input.focus();
      input.setSelectionRange(0, input.value.length);
    }
  };

  _proto.clear = function clear(e) {
    this.set('value', '');
    this.focus();
    this.trigger('clear', e);
  };

  return Input;
}(Component);
Input.template = template;
Input.typeDefs = typeDefs;
Input.defaults = defaults;

__decorate([bind], Input.prototype, "clear", null);