import _extends from "@babel/runtime-corejs3/helpers/extends";
import _objectWithoutPropertiesLoose from "@babel/runtime-corejs3/helpers/objectWithoutPropertiesLoose";
var _excluded = ["className", "style", "type", "value", "defaultValue", "placeholder", "clearable", "disabled", "size", "rows", "autoWidth", "fluid", "width", "stackClearIcon", "frozenOnInput", "readonly", "ev-click", "ev-mounseenter", "ev-mouseleave"];
import { createElementVNode as _$ce, className as _$cn, noop as _$no, createVNode as _$cv, createUnknownComponentVNode as _$cc } from 'intact-vue-next';
import { Icon } from '../icon';
import { addStyle, isTextBlock, getRestProps } from '../utils';
import { makeStyles } from './styles';
import { noop, isNullOrUndefined } from 'intact-shared';
export default function ($props, $blocks, $__proto__) {
  var _classNameObj, children, _children;

  $blocks || ($blocks = {});
  $props || ($props = {});
  var $this = this;
  var _$blocks = {};
  var __$blocks = {};

  var _this$get = this.get(),
      className = _this$get.className,
      style = _this$get.style,
      type = _this$get.type,
      value = _this$get.value,
      defaultValue = _this$get.defaultValue,
      placeholder = _this$get.placeholder,
      clearable = _this$get.clearable,
      disabled = _this$get.disabled,
      size = _this$get.size,
      rows = _this$get.rows,
      autoWidth = _this$get.autoWidth,
      fluid = _this$get.fluid,
      width = _this$get.width,
      stackClearIcon = _this$get.stackClearIcon,
      frozenOnInput = _this$get.frozenOnInput,
      readonly = _this$get.readonly,
      click = _this$get['ev-click'],
      mouseenter = _this$get['ev-mounseenter'],
      mouseleave = _this$get['ev-mouseleave'],
      rest = _objectWithoutPropertiesLoose(_this$get, _excluded);

  var _this$frozen = this.frozen,
      inputing = _this$frozen.inputing.value,
      originalValue = _this$frozen.originalValue.value,
      startInput = _this$frozen.startInput,
      onInput = _this$frozen.onInput,
      endInput = _this$frozen.endInput;
  var classNameObj = (_classNameObj = {
    'k-input': true
  }, _classNameObj["k-" + size] = size !== 'default', _classNameObj['k-group'] = $blocks.prepend || $blocks.append, _classNameObj['k-disabled'] = disabled, _classNameObj['k-with-prefix'] = $blocks.prefix, _classNameObj['k-with-suffix'] = $blocks.suffix, _classNameObj['k-clearable'] = clearable, _classNameObj['k-auto-width'] = autoWidth, _classNameObj['k-fluid'] = fluid, _classNameObj['k-stack-clear'] = stackClearIcon, _classNameObj[className] = className, _classNameObj[makeStyles()] = true, _classNameObj);
  var _this$autoWidth = this.autoWidth,
      fakeRef = _this$autoWidth.fakeRef,
      fakeWidth = _this$autoWidth.width.value;
  var inputValue = frozenOnInput && inputing ? originalValue : value;
  var hasInputValue = !isNullOrUndefined(inputValue);
  var hasValue = hasInputValue && inputValue !== '';

  var inputProps = _extends({}, getRestProps(this, rest), {
    'ev-focus': startInput,
    'ev-blur': endInput,
    'ev-input': onInput,
    defaultValue: defaultValue,
    readOnly: readonly,
    placeholder: placeholder,
    disabled: disabled,
    ref: this.inputRef,
    style: autoWidth ? {
      width: fakeWidth + 'px'
    } : undefined
  }); // if we pass value to input element, the input is controlled and the
  // defaultValue does not work


  if (hasInputValue) {
    inputProps.value = inputValue;
  }

  return _$ce(2, 'div', [$blocks.prepend ? (children = $blocks.prepend(noop), _$ce(2, 'div', children, 0, _$cn({
    "k-input-prepend": true,
    "k-input-padding": isTextBlock(children)
  }))) : void 0, _$ce(2, 'div', [$blocks.prefix ? _$ce(2, 'div', (_$blocks['prefix'] = function ($super) {
    return null;
  }, __$blocks['prefix'] = function ($super, data) {
    var block = $blocks['prefix'];

    var callBlock = function callBlock() {
      return _$blocks['prefix'].call($this, $super, data);
    };

    return block ? block.call($this, callBlock, data) : callBlock();
  }, __$blocks['prefix'](_$no)), 0, 'k-input-prefix') : undefined, type !== 'textarea' ? _$cv('input', _extends({}, inputProps, {
    'className': 'k-input-inner',
    'type': type
  })) : _$cv('textarea', _extends({}, inputProps, {
    'className': 'k-input-inner k-textarea',
    'rows': rows
  })), $blocks.suffix || clearable && !disabled ? _$ce(2, 'div', [clearable && !disabled ? _$cc(Icon, {
    'className': _$cn({
      "k-input-clear ion-ios-close": true,
      "k-input-show": hasValue
    }),
    'ev-click': this.clear
  }) : undefined, ' ', (_$blocks['suffix'] = function ($super) {
    return null;
  }, __$blocks['suffix'] = function ($super, data) {
    var block = $blocks['suffix'];

    var callBlock = function callBlock() {
      return _$blocks['suffix'].call($this, $super, data);
    };

    return block ? block.call($this, callBlock, data) : callBlock();
  }, __$blocks['suffix'](_$no))], 0, 'k-input-suffix') : undefined, autoWidth ? _$ce(2, 'div', !hasValue ? placeholder : inputValue, 0, 'k-input-fake', null, null, fakeRef) : undefined], 0, 'k-input-wrapper'), $blocks.append ? (_children = $blocks.append(noop), _$ce(2, 'div', _children, 0, _$cn({
    "k-input-append": true,
    "k-input-padding": isTextBlock(_children)
  }))) : void 0], 0, _$cn(classNameObj), {
    'style': width != null ? addStyle(style, {
      width: width + "px"
    }) : style,
    'ev-click': click,
    'ev-mouseenter': mouseenter,
    'ev-mouseleave': mouseleave
  });
}
;