import { useInstance, createRef, onMounted } from 'intact-vue-next';
import { useState } from '../../hooks/useState';
export function useAutoWidth() {
  var instance = useInstance();
  var fakeRef = createRef();
  var width = useState(0);
  instance.watch('value', adjustWidth, {
    inited: true,
    presented: true
  });
  instance.watch('placeholder', adjustWidth, {
    inited: true,
    presented: true
  });
  onMounted(adjustWidth);

  function adjustWidth() {
    if (instance.get('autoWidth')) {
      var _width = fakeRef.value.offsetWidth || 1;

      width.set(_width);
    }
  }

  return {
    fakeRef: fakeRef,
    width: width
  };
}