import _mapInstanceProperty from "@babel/runtime-corejs3/core-js/instance/map";
import { css } from '@emotion/css';
import { theme } from '../../styles/theme';
import { deepDefaults, getLeft } from '../../styles/utils';
import '../../styles/global';
import { menu } from '../menu/styles';
var sizes = ['small', 'large'];
export var themes = ['light', 'dark', 'white'];

var _deepDefaults = deepDefaults(theme, {
  layout: {
    get color() {
      return menu.item.color;
    },

    get bgColor() {
      return menu.bgColor;
    },

    light: {
      get color() {
        return menu.light.bgColor;
      },

      get bgColor() {
        return menu.light.bgColor;
      },

      get border() {
        return menu.light.border;
      }

    },
    white: {
      get color() {
        return menu.white.bgColor;
      },

      get bgColor() {
        return menu.white.bgColor;
      },

      get border() {
        return menu.white.border;
      }

    },

    get collapsedWidth() {
      return "calc(" + getLeft(menu.item.padding) + " * 2 + " + menu.icon.width + ")";
    },

    footerPadding: '24px 50px',
    bodyMargin: '0 20px'
  }
}),
    layout = _deepDefaults.layout;

export function getCollapseWidth() {
  return layout.collapsedWidth;
}
export function makeLayoutStyles() {
  return /*#__PURE__*/css("display:flex;flex-direction:column;flex:1;transition:padding-left ", theme.transition, ";&.k-has-aside{flex-direction:row;}.k-layout-footer{padding:", layout.footerPadding, ";}.k-layout-body{flex:1;margin:", layout.bodyMargin, ";}");
}
export function makeHeaderStyles() {
  return /*#__PURE__*/css("display:flex;align-items:center;color:", layout.color, ";background:", layout.bgColor, ";left:0;transition:left ", theme.transition, ";&.k-fixed{position:fixed;left:0;right:0;top:0;z-index:", theme.midZIndex, ";}", _mapInstanceProperty(themes).call(themes, function (theme) {
    if (theme === 'dark') return;
    var styles = layout[theme];
    return /*#__PURE__*/css("&.k-", theme, "{background:", styles.bgColor, ";color:", styles.color, ";border-bottom:", styles.border, ";}");
  }), ";");
}
export function makeAsideStyles() {
  return /*#__PURE__*/css("transition:width ", theme.transition, ";display:flex;flex-direction:column;background:", layout.bgColor, ";color:", layout.color, ";", _mapInstanceProperty(themes).call(themes, function (theme) {
    if (theme === 'dark') return;
    var styles = layout[theme];
    return /*#__PURE__*/css("&.k-", theme, "{background:", styles.bgColor, ";color:", styles.color, ";border-right:", styles.border, ";}");
  }), " &.k-fixed{position:fixed;overflow:auto;left:0;top:0;bottom:0;z-index:", theme.midZIndex, ";}.k-menu{width:auto!important;}");
}