import { Component, TypeDefs, Key } from 'intact-vue-next';
import { Menu } from './menu';
export interface MenuItemProps {
    key: Key;
    to?: string;
    dot?: boolean;
    disabled?: boolean;
}
export interface MenuItemEvents {
    click: [MouseEvent];
    select: [MenuItem, MouseEvent];
}
export declare const MENU_ITEM = "MenuItem";
export declare class MenuItem extends Component<MenuItemProps, MenuItemEvents> {
    static template: import("intact").Template<any>;
    static typeDefs: Required<TypeDefs<MenuItemProps>>;
    rootMenu: Menu;
    parentMenu: Menu;
    parentMenuItem: MenuItem | null;
    private expanded;
    private highlight;
    private dropdown;
    private router;
    init(): void;
    onClick(hasSubMenu: Menu, e: MouseEvent): void;
}
