import _extends from "@babel/runtime-corejs3/helpers/extends";
import { createElementVNode as _$ce, createUnknownComponentVNode as _$cc, className as _$cn, createVNode as _$cv, extend as _$ex, EMPTY_OBJ as _$em } from 'intact-vue-next';
import { directClone, Transition } from 'intact';
import { Dropdown, DropdownItem } from '../dropdown';
import { Tooltip } from '../tooltip';
import { Icon } from '../icon';
import { Menu } from './menu';
import { getRestProps, expandAnimationCallbacks } from '../utils';
import { isNullOrUndefined } from 'intact-shared';
import { makeItemStyles, makeTitleStyles } from './styles';
var _$tmp0 = {
  'className': 'k-menu-dot ion-record'
};
export default function ($props, $blocks, $__proto__) {
  var _classNameObj,
      _this = this;

  $blocks || ($blocks = {});
  $props || ($props = {});
  var $this = this;
  var rootMenu = this.rootMenu;

  var _rootMenu$get = rootMenu.get(),
      theme = _rootMenu$get.theme,
      type = _rootMenu$get.type,
      rootDot = _rootMenu$get.dot;

  var _this$get = this.get(),
      children = _this$get.children,
      key = _this$get.key,
      className = _this$get.className,
      disabled = _this$get.disabled,
      dot = _this$get.dot;

  var _this$highlight = this.highlight,
      isHighlighted = _this$highlight.isHighlighted,
      isSelected = _this$highlight.isSelected;
  var isExpandedKey = this.expanded.isExpanded;
  var isExpanded = isExpandedKey(key);

  var _this$dropdown = this.dropdown(),
      isTopItem = _this$dropdown.isTopItem,
      subMenuVNode = _this$dropdown.subMenuVNode,
      isDropdownMenu = _this$dropdown.isDropdownMenu,
      tooltipContents = _this$dropdown.tooltipContents,
      iconVNode = _this$dropdown.iconVNode,
      titleVNodes = _this$dropdown.titleVNodes,
      position = _this$dropdown.position,
      isCollapse = _this$dropdown.isCollapse;

  var classNameObj = (_classNameObj = {
    'k-menu-item': true
  }, _classNameObj[className] = className, _classNameObj['k-expanded'] = isExpanded, _classNameObj['k-disabled'] = disabled, _classNameObj['k-active'] = isSelected(), _classNameObj['k-highlighted'] = isHighlighted(), _classNameObj[makeItemStyles()] = true, _classNameObj);
  var showDot = isTopItem && !iconVNode && isNullOrUndefined(dot) ? rootDot : dot;

  var title = function title(children) {
    var _$cn2;

    return _$ce(2, 'div', [showDot ? _$cc(Icon, _$tmp0) : undefined, _$ce(2, 'div', children, 0, 'k-menu-name'), subMenuVNode ? _$ce(2, 'i', null, 1, 'k-menu-arrow ion-ios-arrow-down') : undefined], 0, _$cn((_$cn2 = {
      'k-menu-title': true
    }, _$cn2[makeTitleStyles()] = true, _$cn2)), {
      'ev-click': _this.onClick.bind(_this, subMenuVNode)
    });
  };

  return _$cv('div', _extends({
    'className': _$cn(classNameObj)
  }, getRestProps(this)), !isDropdownMenu ? [title(titleVNodes), _$cc(Transition, _extends({
    'show': isExpanded,
    'key': 'subMenu'
  }, expandAnimationCallbacks, {
    'children': subMenuVNode
  }), 'subMenu')] : !subMenuVNode ? isTopItem && isCollapse ? _$cc(Tooltip, {
    'position': rootMenu.get('type') !== 'horizontal' ? 'right' : 'bottom',
    'theme': rootMenu.get('theme') === 'dark' ? 'dark' : 'light',
    'children': title(iconVNode),
    '$blocks': function ($blocks) {
      var _$blocks = {},
          __$blocks = _$ex({}, $blocks);

      return (_$blocks['content'] = function ($super) {
        return tooltipContents;
      }, __$blocks['content'] = function ($super, data) {
        var block = $blocks['content'];

        var callBlock = function callBlock() {
          return _$blocks['content'].call($this, $super, data);
        };

        return block ? block.call($this, callBlock, data) : callBlock();
      }), __$blocks;
    }.call($this, _$em)
  }) : title(titleVNodes) : [_$cc(Dropdown, {
    'position': position,
    'children': [title(isTopItem && isCollapse ? iconVNode : titleVNodes), subMenuVNode]
  }), _$cc(Transition, _extends({
    'show': isExpanded,
    'key': 'subMenu'
  }, expandAnimationCallbacks), 'subMenu')]);
}
;