import _Set from "@babel/runtime-corejs3/core-js/set";
import _mapInstanceProperty from "@babel/runtime-corejs3/core-js/instance/map";
import _Array$from from "@babel/runtime-corejs3/core-js/array/from";
import { useInstance } from 'intact-vue-next';
import { inArray } from '../table/useChecked'; // import {isEqualArray} from '../utils';

export function useHighlight(rootMenu, parentMenuItem) {
  var instance = useInstance(); // we can not watch selectedKey on before initializing rootMenu
  // because rootMenu has initialized
  // so call updateStatus here

  updateStatus(rootMenu.get('selectedKey'));
  rootMenu.watch('selectedKey', updateStatus);

  function updateStatus(v) {
    var _instance$get = instance.get(),
        key = _instance$get.key;

    if (v !== key) return;
    var items = [];
    var parentItem = parentMenuItem;

    while (parentItem) {
      items.push(parentItem);
      parentItem = parentItem.parentMenuItem;
    }

    var expandedKeys = new _Set(rootMenu.get('expandedKeys'));

    var highlightedKeys = _mapInstanceProperty(items).call(items, function (item) {
      var key = item.get('key');
      expandedKeys.add(key);
      return key;
    });

    rootMenu.highlightedKeys = highlightedKeys;
    rootMenu.set('expandedKeys', _Array$from(expandedKeys));
  }

  function isHighlighted() {
    return inArray(rootMenu.highlightedKeys, instance.get('key'));
  }

  function select() {
    rootMenu.set('selectedKey', instance.get('key'));
  }

  function isSelected() {
    return rootMenu.get('selectedKey') === instance.get('key');
  }

  return {
    isHighlighted: isHighlighted,
    updateStatus: updateStatus,
    select: select,
    isSelected: isSelected
  };
}