import { Component, TypeDefs, Children } from 'intact-vue-next';
export interface MessageProps {
    content?: Children;
    duration?: number;
    type?: 'info' | 'error' | 'success' | 'warning';
    closable?: boolean;
    hideIcon?: boolean;
}
export declare class Message extends Component<MessageProps> {
    static template: import("intact").Template<any>;
    static typeDefs: Required<TypeDefs<MessageProps>>;
    static defaults: () => Partial<MessageProps>;
    static notice(content: Children | Partial<MessageProps>, duration?: number, type?: MessageProps['type']): void;
    static info(content: Children | Partial<MessageProps>, duration?: number): void;
    static error(content: Children | Partial<MessageProps>, duration?: number): void;
    static success(content: Children | Partial<MessageProps>, duration?: number): void;
    static warning(content: Children | Partial<MessageProps>, duration?: number): void;
    private delayClose;
    close(): void;
}
