import _extends from "@babel/runtime-corejs3/helpers/extends";
import { createCommentVNode as _$ccv, createUnknownComponentVNode as _$cc, createElementVNode as _$ce, createTextVNode as _$ct, createVNode as _$cv, className as _$cn, map as _$ma } from 'intact-vue-next';
import { getRestProps, mapChildren } from '../utils';
import { ButtonGroup, Button } from '../button';
import { Select, Option } from '../select';
import { Input } from '../input';
import { Icon } from '../icon';
import { _$ } from '../../i18n';
import { makeStyles } from './styles';
var _$tmp0 = {
  'className': 'ion-ios-arrow-left'
};
var _$tmp1 = {
  'className': 'ion-ios-arrow-right'
};
export default function ($props, $blocks, $__proto__) {
  var _classNameObj;

  $blocks || ($blocks = {});
  $props || ($props = {});
  var $this = this;

  var _this$get = this.get(),
      total = _this$get.total,
      size = _this$get.size,
      noBorder = _this$get.noBorder,
      simple = _this$get.simple,
      className = _this$get.className,
      showTotal = _this$get.showTotal,
      showGoto = _this$get.showGoto,
      counts = _this$get.counts,
      current = _this$get.current,
      limit = _this$get.limit,
      limits = _this$get.limits,
      showLimits = _this$get.showLimits;

  if (!total) return _$ccv(' pagination ');
  var classNameObj = (_classNameObj = {
    'k-pagination': true
  }, _classNameObj[className] = className, _classNameObj["k-" + size] = size !== 'default', _classNameObj['k-no-border'] = noBorder, _classNameObj['k-simple'] = simple, _classNameObj[makeStyles()] = true, _classNameObj);
  var type = 'default';

  if (noBorder || simple) {
    type = 'none';
  }

  var totalPages = Math.ceil(total / limit) || 0;

  var paginationButton = function paginationButton(page) {
    return _$cc(Button, {
      'type': type,
      'size': size,
      'icon': true,
      'value': page,
      'children': page
    });
  };

  var paginationDot = function paginationDot(callback) {
    return _$cc(Button, {
      'type': type,
      'size': size,
      'icon': true,
      'className': 'k-pagination-ellipsis',
      'ev-click': callback,
      'children': '...'
    });
  };

  var paginationItems = [];
  var minCount = Math.ceil(counts / 2);
  var maxCount = totalPages - minCount;
  var prevPage = current - 1;
  var nextPage = current + 1;

  if (!simple) {
    if (totalPages > counts) {
      if (current <= minCount) {
        var max = counts - 2;

        for (var i = 1; i <= max; i++) {
          paginationItems.push(paginationButton(i));
        }

        paginationItems.push(paginationDot(this.fastNext));
        paginationItems.push(paginationButton(totalPages));
      } else if (current > minCount && current <= maxCount) {
        paginationItems.push(paginationButton(1));
        paginationItems.push(paginationDot(this.fastPrev));
        var midCount = counts - 4;
        var mid = Math.floor(midCount / 2);
        var min = current - mid;

        var _max = midCount % 2 === 1 ? current + mid : current + mid - 1;

        for (var _i = min; _i <= _max; _i++) {
          paginationItems.push(paginationButton(_i));
        }

        paginationItems.push(paginationDot(this.fastNext));
        paginationItems.push(paginationButton(totalPages));
      } else {
        paginationItems.push(paginationButton(1));
        paginationItems.push(paginationDot(this.fastPrev));

        var _min = totalPages - counts + 3;

        for (var _i2 = _min; _i2 <= totalPages; _i2++) {
          paginationItems.push(paginationButton(_i2));
        }
      }
    } else {
      for (var _i3 = 1; _i3 <= totalPages; _i3++) {
        paginationItems.push(paginationButton(_i3));
      }
    }
  } else {
    paginationItems = [_$cc(Input, {
      'size': size === 'mini' || size === 'small' ? 'mini' : 'small',
      'autoWidth': true,
      'value': current,
      'ev-change': this.goto
    }), _$ce(2, 'span', [_$ct(' / '), totalPages], 0, 'k-pagination-text')];
  }

  return _$cv('div', _extends({
    'className': _$cn(classNameObj)
  }, getRestProps(this)), [_$cc(ButtonGroup, {
    'checkType': 'radio',
    'children': [_$cc(Button, {
      'icon': true,
      'size': size,
      'type': type,
      'disabled': current <= 1,
      'ev-click': this.prev,
      'children': _$cc(Icon, _$tmp0)
    }), paginationItems, _$cc(Button, {
      'icon': true,
      'size': size,
      'type': type,
      'disabled': current >= totalPages,
      'ev-click': this.next,
      'children': _$cc(Icon, _$tmp1)
    })],
    'ev-$model:value': function ev$modelValue($v) {
      $this.set('current', $v);
    },
    'value': $this.get('current')
  }), !simple ? [showLimits ? _$ce(2, 'div', _$cc(Select, {
    'allowUnmatch': true,
    'size': size,
    'children': _$ma(limits, function ($value, $key) {
      return _$cc(Option, {
        'value': $value,
        'children': _$('{n} 条 / 页', {
          n: $value
        })
      });
    }, $this),
    'ev-$model:value': function ev$modelValue($v) {
      $this.set('limit', $v);
    },
    'value': $this.get('limit')
  }), 2, 'k-pagination-limits') : undefined, showGoto ? _$ce(2, 'div', [_$ce(2, 'span', _$('跳至'), 0, 'c-middle'), _$cc(Input, {
    'size': size,
    'value': current,
    'ev-change': this.goto
  }), _$ce(2, 'span', _$('页'), 0, 'c-middle')], 4, 'k-pagination-goto') : undefined, showTotal ? _$ce(2, 'div', _$('共 {n} 条', {
    n: total
  }), 0, 'k-pagination-total') : undefined] : undefined]);
}
;