import _inheritsLoose from "@babel/runtime-corejs3/helpers/inheritsLoose";
import _concatInstanceProperty from "@babel/runtime-corejs3/core-js/instance/concat";
import { Component, createCommentVNode, createTextVNode, mount, removeVNodeDom, patch, remove, inject } from 'intact-vue-next';
import { isString } from 'intact-shared';
import { DIALOG } from './dialog/constants';
var typeDefs = {
  container: [String, Function]
};
export var Portal = /*#__PURE__*/function (_Component) {
  _inheritsLoose(Portal, _Component);

  function Portal() {
    var _context;

    var _this;

    for (var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    _this = _Component.call.apply(_Component, _concatInstanceProperty(_context = [this]).call(_context, args)) || this;
    _this.container = null;
    _this.dialog = inject(DIALOG, null);
    return _this;
  }

  Portal.template = function template() {
    if (process.env.NODE_ENV === 'production') {
      return createTextVNode('');
    }

    return createCommentVNode('portal');
  };

  var _proto = Portal.prototype;

  _proto.$render = function $render(lastVNode, nextVNode, parentDom, anchor, mountedQueue) {
    var nextProps = nextVNode.props;
    this.initContainer(nextProps.container, parentDom, anchor);
    mount(nextProps.children, this.container, this, this.$SVG, null, mountedQueue);

    _Component.prototype.$render.call(this, lastVNode, nextVNode, parentDom, anchor, mountedQueue);
  };

  _proto.$update = function $update(lastVNode, nextVNode, parentDom, anchor, mountedQueue, force) {
    // update container if it has changed
    var lastProps = lastVNode.props;
    var nextProps = nextVNode.props;
    var lastContainer = this.container;

    if (lastProps.container !== nextProps.container) {
      this.initContainer(nextProps.container, parentDom, anchor);
    }

    var nextContainer = this.container;

    if (lastContainer === nextContainer) {
      patch(lastProps.children, nextProps.children, nextContainer, this, this.$SVG, anchor, mountedQueue, false);
    } else {
      remove(lastProps.children, lastContainer, false);
      mount(nextProps.children, nextContainer, this, this.$SVG, anchor, mountedQueue);
    }

    _Component.prototype.$update.call(this, lastVNode, nextVNode, parentDom, anchor, mountedQueue, force);
  };

  _proto.$unmount = function $unmount(vNode, nextVNode) {
    removeVNodeDom(vNode.props.children, this.container);

    _Component.prototype.$unmount.call(this, vNode, nextVNode);
  };

  _proto.initContainer = function initContainer(container, parentDom, anchor) {
    if (container) {
      if (isString(container)) {
        this.container = document.querySelector(container);
      } else {
        this.container = container(parentDom, anchor);
      }
    }

    if (!this.container) {
      // find the closest dialog if exists
      var tmp;

      if ((tmp = this.dialog) && (tmp = tmp.dialogRef.value)) {
        this.container = tmp;
      } else {
        this.container = document.body;
      }
    }
  };

  return Portal;
}(Component);
Portal.typeDefs = typeDefs;