import { Component, TypeDefs } from 'intact-vue-next';
declare type Sizes = 'default' | 'small' | 'mini';
declare type Type = 'bar' | 'circle';
declare type Status = 'active' | 'success' | 'error' | 'normal' | 'warning';
declare type percent = number | string;
declare type color = {
    percent: percent;
    color: string;
};
export interface ProgressProps {
    type?: Type;
    percent?: percent;
    size?: Sizes;
    showOuterText?: boolean;
    showInnerText?: boolean;
    status?: Status;
    strokeWidth?: number;
    color?: string | color[] | ((percent: percent) => string);
}
export declare class Progress extends Component<ProgressProps> {
    static template: import("intact").Template<any>;
    static typeDefs: Required<TypeDefs<ProgressProps>>;
    static defaults: () => Partial<ProgressProps>;
    status: import("../../hooks/useState").State<Status>;
    color: import("../../hooks/useState").State<string | color[] | ((percent: percent) => string) | undefined>;
    init(): void;
}
export {};
