import { Component, Children, TypeDefs, RefObject } from 'intact-vue-next';
import { Sizes } from '../../styles/utils';
import type { Input } from '../input';
import { Dropdown } from '../dropdown';
import { State } from '../../hooks/useState';
import { Container } from '../portal';
export interface BaseSelectProps {
    value?: any;
    multiple?: boolean;
    filterable?: boolean;
    loading?: boolean;
    disabled?: boolean;
    name?: string;
    size?: Sizes;
    hideIcon?: boolean;
    clearable?: boolean;
    fluid?: boolean;
    inline?: boolean;
    placeholder?: Children;
    container?: Container;
    width?: string | number;
    _show?: boolean;
}
export interface BaseSelectEvents {
    keypress: [KeyboardEvent];
    show: [];
    hide: [];
}
export interface BaseSelectBlocks {
    value: [any, Children];
    values: [any[], Children[]];
    prefix: null;
    suffix: null;
}
export declare abstract class BaseSelect<T extends BaseSelectProps = BaseSelectProps, E extends BaseSelectEvents = BaseSelectEvents, B extends BaseSelectBlocks = BaseSelectBlocks> extends Component<T, E, B> {
    static template: import("intact").Template<any>;
    static typeDefs: Required<TypeDefs<BaseSelectProps>>;
    static defaults: () => Partial<BaseSelectProps>;
    dropdownRef: RefObject<Dropdown>;
    input: {
        onInput: (value: string) => void;
        keywords: State<string>;
        inputRef: RefObject<Input>;
    };
    init(): void;
    protected abstract getPlaceholder(): Children;
    protected abstract getLabel(): Children;
    position(): void;
    show(): void;
    hide(): void;
    resetKeywords(keywords: State<string>): void;
    private delete;
    protected clear(e: MouseEvent): void;
    private onKeypress;
}
