import _inheritsLoose from "@babel/runtime-corejs3/helpers/inheritsLoose";
import _concatInstanceProperty from "@babel/runtime-corejs3/core-js/instance/concat";
import _sliceInstanceProperty from "@babel/runtime-corejs3/core-js/instance/slice";
import _spliceInstanceProperty from "@babel/runtime-corejs3/core-js/instance/splice";
import { __decorate } from "tslib";
import { Component, provide, createRef } from 'intact-vue-next';
import template from './base.vdt';
import { sizes } from '../../styles/utils';
import { SELECT } from './constants';
import { useShowHideEvents } from '../../hooks/useShowHideEvents';
import { bind } from '../utils';
import { useInput } from './useInput';
var typeDefs = {
  value: null,
  multiple: Boolean,
  filterable: Boolean,
  loading: Boolean,
  disabled: Boolean,
  name: String,
  size: sizes,
  hideIcon: Boolean,
  clearable: Boolean,
  fluid: Boolean,
  inline: Boolean,
  placeholder: [String, Number],
  container: [Function, String],
  width: [String, Number],
  _show: Boolean
};

var defaults = function defaults() {
  return {
    size: 'default'
  };
};

export var BaseSelect = /*#__PURE__*/function (_Component) {
  _inheritsLoose(BaseSelect, _Component);

  function BaseSelect() {
    var _context;

    var _this;

    for (var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    _this = _Component.call.apply(_Component, _concatInstanceProperty(_context = [this]).call(_context, args)) || this;
    _this.dropdownRef = createRef();
    _this.input = useInput(_this.resetKeywords);
    return _this;
  }

  var _proto = BaseSelect.prototype;

  _proto.init = function init() {
    provide(SELECT, this);
    useShowHideEvents('_show'); // this.input = useInput();

    this.watch('value', this.position, {
      presented: true
    });
  };

  _proto.position = function position() {
    var dropdown = this.dropdownRef.value;

    if (dropdown.get('value')) {
      dropdown.position();
    }
  };

  _proto.show = function show() {
    this.set('_show', true);
  };

  _proto.hide = function hide() {
    this.set('_show', false);
  };

  _proto.resetKeywords = function resetKeywords(keywords) {
    keywords.set('');
  };

  _proto.delete = function _delete(index, e) {
    var _context2;

    if (this.get('disabled')) return;
    e.stopPropagation();

    var value = _sliceInstanceProperty(_context2 = this.get('value')).call(_context2, 0);

    _spliceInstanceProperty(value).call(value, index, 1);

    this.set('value', value);
  };

  _proto.clear = function clear(e) {
    e.stopPropagation();
    this.set('value', this.get('multiple') ? [] : '');
  };

  _proto.onKeypress = function onKeypress(e) {
    this.trigger('keypress', e);

    switch (e.keyCode) {
      case 13:
        // enter
        this.show();
        break;

      case 9: // tab

      case 27:
        // esc
        this.hide();
        break;
    }
  };

  return BaseSelect;
}(Component);
BaseSelect.template = template;
BaseSelect.typeDefs = typeDefs;
BaseSelect.defaults = defaults;

__decorate([bind], BaseSelect.prototype, "position", null);

__decorate([bind], BaseSelect.prototype, "show", null);

__decorate([bind], BaseSelect.prototype, "hide", null);

__decorate([bind], BaseSelect.prototype, "clear", null);

__decorate([bind], BaseSelect.prototype, "onKeypress", null);