import _extends from "@babel/runtime-corejs3/helpers/extends";
import _valuesInstanceProperty from "@babel/runtime-corejs3/core-js/instance/values";
import { createUnknownComponentVNode as _$cc, createVNode as _$cv, className as _$cn, createElementVNode as _$ce, noop as _$no, map as _$ma } from 'intact-vue-next';
import { TransitionGroup, Transition } from 'intact';
import { Input } from '../input';
import { Icon } from '../icon';
import { isNullOrUndefined } from 'intact-shared';
import makeStyles from './styles';
import { Dropdown } from '../dropdown';
import { getRestProps, addStyle } from '../utils';
var _$tmp0 = {
  'className': 'ion-load-c',
  'rotate': true
};
export default function ($props, $blocks, $__proto__) {
  var _classNameObj;

  $blocks || ($blocks = {});
  $props || ($props = {});
  var $this = this;
  var _$blocks = {};
  var __$blocks = {};

  var _this$get = this.get(),
      value = _this$get.value,
      multiple = _this$get.multiple,
      loading = _this$get.loading,
      disabled = _this$get.disabled,
      name = _this$get.name,
      size = _this$get.size,
      hideIcon = _this$get.hideIcon,
      fluid = _this$get.fluid,
      clearable = _this$get.clearable,
      filterable = _this$get.filterable,
      className = _this$get.className,
      container = _this$get.container,
      inline = _this$get.inline,
      style = _this$get.style,
      width = _this$get.width,
      _show = _this$get._show;

  var classNameObj = (_classNameObj = {
    'k-select': true,
    'k-disabled': disabled
  }, _classNameObj["k-" + size] = size !== 'default', _classNameObj['k-fluid'] = fluid, _classNameObj['k-inline'] = inline, _classNameObj[className] = className, _classNameObj[$props.className] = $props.className, _classNameObj[makeStyles()] = true, _classNameObj);
  var placeholder = this.getPlaceholder();
  var label = this.getLabel();
  var hasValue = !isNullOrUndefined(value) && (multiple ? value.length : value !== '');
  var _this$input = this.input,
      onInput = _this$input.onInput,
      inputRef = _this$input.inputRef,
      keywords = _this$input.keywords.value;
  return _$cc(Dropdown, {
    'trigger': 'click',
    'ref': this.dropdownRef,
    'disabled': disabled,
    'container': container,
    'children': [_$cv('div', _extends({}, getRestProps(this), {
      'className': _$cn(classNameObj),
      'tabindex': '0',
      'ev-keydown': this.onKeypress,
      'style': !isNullOrUndefined(width) ? addStyle(style, {
        width: width + "px"
      }) : style
    }), [$blocks.prefix ? _$ce(2, 'div', (_$blocks['prefix'] = function ($super) {
      return null;
    }, __$blocks['prefix'] = function ($super, data) {
      var block = $blocks['prefix'];

      var callBlock = function callBlock() {
        return _$blocks['prefix'].call($this, $super, data);
      };

      return block ? block.call($this, callBlock, data) : callBlock();
    }, __$blocks['prefix'](_$no)), 0, 'k-select-prefix') : undefined, _$ce(2, 'div', [_$ce(64, 'input', null, 1, null, {
      'type': 'hidden',
      'value': value,
      'name': name
    }, 'hidden-input'), null, _$cc(TransitionGroup, {
      'name': 'k-fade',
      'appear': false,
      'children': !multiple && filterable ? _$cc(Input, {
        'value': _show ? keywords : label,
        'ev-$change:value': onInput,
        'disabled': disabled,
        'placeholder': label || placeholder,
        'ref': inputRef,
        'size': size,
        'fluid': true,
        'key': 'input',
        'readonly': !_show
      }, 'input', inputRef) : !filterable && !hasValue ? _$ce(2, 'div', placeholder, 0, 'k-select-placeholder c-ellipsis', null, 'placeholder') : !multiple ? _$ce(2, 'div', (_$blocks['value'] = function ($super) {
        return label;
      }, __$blocks['value'] = function ($super, data) {
        var block = $blocks['value'];

        var callBlock = function callBlock() {
          return _$blocks['value'].call($this, $super, data);
        };

        return block ? block.call($this, callBlock, data) : callBlock();
      }, __$blocks['value'](_$no, [value, label])), 0, 'k-select-value c-ellipsis', null, 'value') : _$ce(2, 'div', [_$cc(TransitionGroup, {
        'name': 'k-fade',
        'children': (_$blocks['values'] = function ($super) {
          return _$ma(label, function ($value, $key) {
            return _$ce(2, 'div', [_$ce(2, 'span', (_$blocks['value'] = function ($super) {
              return $value;
            }, __$blocks['value'] = function ($super, data) {
              var block = $blocks['value'];

              var callBlock = function callBlock() {
                return _$blocks['value'].call($this, $super, data);
              };

              return block ? block.call($this, callBlock, data) : callBlock();
            }, __$blocks['value'](_$no, [value[$key], $value])), 0, 'k-select-text'), _$cc(Icon, {
              'className': 'ion-ios-close k-select-close',
              'ev-click': this.delete.bind(this, $key),
              'hoverable': !disabled
            })], 4, 'k-select-tag', null, $value);
          }, $this);
        }, __$blocks['values'] = function ($super, data) {
          var block = _valuesInstanceProperty($blocks);

          var callBlock = function callBlock() {
            return _valuesInstanceProperty(_$blocks).call($this, $super, data);
          };

          return block ? block.call($this, callBlock, data) : callBlock();
        }, _valuesInstanceProperty(__$blocks).call(__$blocks, _$no, [value, label]))
      }), filterable ? _$cc(Input, {
        'className': 'k-select-input',
        'value': keywords,
        'ev-$change:value': onInput,
        'disabled': disabled,
        'placeholder': !hasValue ? placeholder : '',
        'ref': inputRef,
        'autoWidth': true,
        'size': size,
        'key': 'filter',
        'readonly': !_show
      }, 'filter', inputRef) : undefined], 0, _$cn({
        "k-select-values": true,
        "k-with-values": _valuesInstanceProperty($blocks)
      }), null, 'values')
    })], 0, 'k-select-main'), !hideIcon || clearable || loading || $blocks.suffix ? _$ce(2, 'span', [clearable && !disabled ? _$cc(Icon, {
      'className': _$cn({
        "k-select-clear ion-ios-close": true,
        "k-show": hasValue
      }),
      'ev-click': this.clear,
      'hoverable': true
    }) : undefined, _$ce(2, 'span', (_$blocks['suffix'] = function ($super) {
      return loading ? _$cc(Icon, _$tmp0) : !hideIcon ? _$cc(Icon, {
        'className': _$cn({
          "k-select-arrow ion-ios-arrow-down": true,
          'k-disabled': $props.isDisableArrow
        })
      }) : undefined;
    }, __$blocks['suffix'] = function ($super, data) {
      var block = $blocks['suffix'];

      var callBlock = function callBlock() {
        return _$blocks['suffix'].call($this, $super, data);
      };

      return block ? block.call($this, callBlock, data) : callBlock();
    }, __$blocks['suffix'](_$no)), 0, 'k-select-suffix-icon')], 0, 'k-select-suffix') : undefined]), (_$blocks['base-menu'] = function ($super) {
      return _$ce(2, 'div', 'should be implemeted', 16);
    }, __$blocks['base-menu'] = function ($super, data) {
      var block = $blocks['base-menu'];

      var callBlock = function callBlock() {
        return _$blocks['base-menu'].call($this, $super, data);
      };

      return block ? block.call($this, callBlock, data) : callBlock();
    }, __$blocks['base-menu'](_$no))],
    'ev-$model:value': function ev$modelValue($v) {
      $this.set('_show', $v);
    },
    'value': $this.get('_show')
  }, null, this.dropdownRef);
}
;