import { Children, TypeDefs } from 'intact-vue-next';
import { Option } from './option';
import { BaseSelect, BaseSelectProps, BaseSelectEvents, BaseSelectBlocks } from './base';
export interface SelectProps extends BaseSelectProps {
    filter?: (keywords: string, props: any) => boolean;
    searchable?: boolean;
    creatable?: boolean;
    labelMap?: Map<any, Children>;
    card?: boolean;
    autoDisableArrow: boolean;
}
export interface SelectEvents extends BaseSelectEvents {
}
export interface SelectBlocks extends BaseSelectBlocks {
    menu: null;
}
export declare class Select extends BaseSelect<SelectProps, SelectEvents, SelectBlocks> {
    static template: import("intact").Template<any>;
    static typeDefs: Required<TypeDefs<SelectProps>>;
    static defaults: () => Partial<SelectProps>;
    filterable: {
        getCreatedVNode: (children: (string | number | import("intact").VNode<import("intact").VNodeTag>)[]) => import("intact").VNode<typeof Option> | undefined;
        filter: (children: Children) => Children;
    };
    label: {
        getLabel: () => Children;
        activeIndices: import("intact").NonNullableRefObject<number[]>;
    };
    init(): void;
    protected getPlaceholder(): string | number | boolean | import("misstime/dist/utils/types").VNode<any> | Children[];
    protected getLabel(): Children;
    private getAllShowedValues;
}
