import { Component, TypeDefs } from 'intact-vue-next';
import type { StepObject, StepFunction, SpinnerProps } from '../spinner';
import type { TooltipProps } from '../tooltip';
import { Value } from './useValue';
import { Marks } from './useMarks';
export interface SliderProps {
    max?: number;
    min?: number;
    value?: Value;
    isRange?: boolean;
    unit?: string;
    isShowEnd?: boolean;
    isShowInput?: boolean;
    step?: number | StepObject | StepFunction;
    points?: number[] | boolean;
    marks: Marks;
    disabled?: boolean;
    isShowTooltip?: boolean;
    always?: boolean;
    animate?: boolean;
    tooltipProps?: TooltipProps;
    spinnerProps?: SpinnerProps;
}
export interface SliderEvents {
    change: [Value, Value];
}
export interface SliderBlocks {
    tooltip: Value;
}
export declare class Slider extends Component<SliderProps, SliderEvents, SliderBlocks> {
    static template: import("intact").Template<any>;
    static typeDefs: Required<TypeDefs<SliderProps>>;
    static defaults: () => Partial<SliderProps>;
    private step;
    private value;
    private tooltip;
    private draggable;
    private styles;
    private keyboard;
    private click;
    private points;
    private marks;
}
