import { Component, TypeDefs } from 'intact-vue-next';
import { Sizes } from '../../styles/utils';
export interface SpinnerProps {
    disabled?: boolean;
    value?: number;
    max?: number;
    min?: number;
    step?: number | StepObject | StepFunction;
    size?: Sizes;
    vertical?: boolean;
    precision?: number;
    formatter?: Formatter;
    parser?: Parser;
    prefix?: string;
    suffix?: string;
    width?: string | number;
    forceStep?: boolean;
}
export declare type StepObject = {
    [key in number | '$']: number;
};
export declare type StepFunction = (value: number) => number;
declare type Formatter = (value: number) => string;
declare type Parser = (value: string) => number;
export declare class Spinner extends Component<SpinnerProps> {
    static template: import("intact").Template<any>;
    static typeDefs: Required<TypeDefs<SpinnerProps>>;
    static defaults: () => Partial<SpinnerProps>;
    private step;
    private formatter;
    private value;
    private increase;
    private decrease;
    private isDisabledDecrease;
    private isDisabledIncrease;
    private changeValue;
    private onInput;
}
export {};
