import _inheritsLoose from "@babel/runtime-corejs3/helpers/inheritsLoose";
import _concatInstanceProperty from "@babel/runtime-corejs3/core-js/instance/concat";
import _trimInstanceProperty from "@babel/runtime-corejs3/core-js/instance/trim";
import { __decorate } from "tslib";
import { Component } from 'intact-vue-next';
import template from './index.vdt';
import { bind } from '../utils';
import { sizes } from '../../styles/utils';
import { useStep } from './useStep';
import { useFormatter } from './useFormatter';
import { useValue } from './useValue';
var typeDefs = {
  disabled: Boolean,
  value: Number,
  max: Number,
  min: Number,
  step: [Number, Object, Function],
  size: sizes,
  vertical: Boolean,
  precision: Number,
  formatter: Function,
  parser: Function,
  prefix: String,
  suffix: String,
  width: [String, Number],
  forceStep: Boolean
};
var defaultStep = 1;

var defaults = function defaults() {
  return {
    value: 0,
    max: Number.POSITIVE_INFINITY,
    min: Number.NEGATIVE_INFINITY,
    step: defaultStep,
    size: 'default'
  };
};

export var Spinner = /*#__PURE__*/function (_Component) {
  _inheritsLoose(Spinner, _Component);

  function Spinner() {
    var _context;

    var _this;

    for (var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    _this = _Component.call.apply(_Component, _concatInstanceProperty(_context = [this]).call(_context, args)) || this;
    _this.step = useStep(defaultStep);
    _this.formatter = useFormatter();
    _this.value = useValue(_this.step, _this.formatter);
    return _this;
  }

  var _proto = Spinner.prototype;

  _proto.increase = function increase() {
    var _this$get = this.get(),
        value = _this$get.value;

    var _this$step = this.step(value, 'increase'),
        step = _this$step[0];

    this.value.fixValue(Number((value + step).toFixed(10)), 0);
  };

  _proto.decrease = function decrease() {
    var _this$get2 = this.get(),
        value = _this$get2.value;

    var _this$step2 = this.step(value, 'decrease'),
        step = _this$step2[0];

    this.value.fixValue(Number((value - step).toFixed(10)), 0);
  };

  _proto.isDisabledDecrease = function isDisabledDecrease() {
    var _this$get3 = this.get(),
        value = _this$get3.value,
        min = _this$get3.min,
        disabled = _this$get3.disabled;

    return disabled || value <= min;
  };

  _proto.isDisabledIncrease = function isDisabledIncrease() {
    var _this$get4 = this.get(),
        value = _this$get4.value,
        max = _this$get4.max,
        disabled = _this$get4.disabled;

    return disabled || value >= max;
  };

  _proto.changeValue = function changeValue(e) {
    var _context2;

    this.value.fixValue(_trimInstanceProperty(_context2 = e.target.value).call(_context2), this.get('value'));
  } // we need change value as long as the input is valid, #213
  ;

  _proto.onInput = function onInput(e) {
    var val = e.target.value;

    var _this$value$getFixedV = this.value.getFixedValue(_trimInstanceProperty(val).call(val), this.get('value')),
        value = _this$value$getFixedV.value;

    this.value.showValue.set(val);
    this.set({
      value: value
    });
  };

  return Spinner;
}(Component);
Spinner.template = template;
Spinner.typeDefs = typeDefs;
Spinner.defaults = defaults;

__decorate([bind], Spinner.prototype, "increase", null);

__decorate([bind], Spinner.prototype, "decrease", null);

__decorate([bind], Spinner.prototype, "changeValue", null);

__decorate([bind], Spinner.prototype, "onInput", null);