import { Component, TypeDefs } from 'intact-vue-next';
import { Sizes } from '../../styles/utils';
export interface SwitchProps {
    name?: string;
    on?: string;
    off?: string;
    value?: boolean;
    trueValue?: any;
    falseValue?: any;
    width?: number | string;
    height?: number | string;
    size?: Sizes;
    disabled?: boolean;
}
export interface SwitchEvents {
    click: [MouseEvent];
    keypress: [KeyboardEvent];
}
export interface SwitchBlocks {
    off: null;
    on: null;
}
export declare class Switch extends Component<SwitchProps, SwitchEvents, SwitchBlocks> {
    static template: import("intact").Template<any>;
    static typeDefs: Required<TypeDefs<SwitchProps>>;
    static defaults: () => Partial<SwitchProps>;
    private elementRef;
    private draggable;
    private onClick;
    private onClickOnHandle;
    private onKeypress;
    toggle(isKeypress: boolean): void;
    isChecked(): boolean;
    check(): void;
    uncheck(): void;
}
