import { Component, TypeDefs, Children, VNodeComponentClass } from 'intact-vue-next';
export interface TableColumnProps {
    key: string;
    title?: Children;
    sortable?: boolean;
    width?: string | number;
    group?: TableColumnGroupItem[];
    multiple?: boolean;
    ignore?: boolean;
    fixed?: 'left' | 'right';
    align?: 'left' | 'center' | 'right';
    exportTitle?: string;
    exportCell?: (data: any, index: number) => string;
    minWidth?: number;
    cols?: number;
    rows?: number;
    prevVNode?: VNodeComponentClass<TableColumn> | null;
}
export interface TableColumnEvents {
}
export interface TableColumnBlocks<T> {
    title: null;
    template: [T, number];
    default: [T, number];
}
export declare type TableColumnGroupItem = {
    label: Children;
    value: any;
};
export declare class TableColumn<T = any> extends Component<TableColumnProps, TableColumnEvents, TableColumnBlocks<T>> {
    static template: import("intact").Template<any>;
    static typeDefs: Required<TypeDefs<TableColumnProps>>;
    private group;
}
