import _sortInstanceProperty from "@babel/runtime-corejs3/core-js/instance/sort";
import { createUnknownComponentVNode as _$cc, createElementVNode as _$ce, noop as _$no, className as _$cn, map as _$ma } from 'intact-vue-next';
import { getClassAndStyleForFixed } from './useFixedColumns';
import { Dropdown, DropdownMenu, DropdownItem } from '../dropdown';
import { Button } from '../button';
import { Icon } from '../icon';
import { Checkbox } from '../checkbox';
import { makeGroupMenuStyles } from './styles';
import { isStringOrNumber, get } from 'intact-shared';
import { context as GroupContext } from './useGroup';
import { context as SortableContext } from './useSortable';
import { linkEvent } from 'intact';
import { context as TableContext } from './useColumns';
import { context as ResizableContext } from './useResizable';
import { context as FixedColumnsContext } from './useFixedColumns';
var _$tmp0 = {
  'className': 'ion-android-arrow-dropdown'
};
var _$tmp1 = {
  'className': 'ion-android-arrow-dropup k-asc'
};
var _$tmp2 = {
  'className': 'ion-android-arrow-dropdown k-desc'
};
export default function ($props, $blocks, $__proto__) {
  var _this = this;

  $blocks || ($blocks = {});
  $props || ($props = {});
  var $this = this;
  var _$blocks = {};
  var __$blocks = {};

  var _this$get = this.get(),
      title = _this$get.title,
      fixed = _this$get.fixed,
      group = _this$get.group,
      multiple = _this$get.multiple,
      key = _this$get.key,
      sortable = _this$get.sortable,
      cols = _this$get.cols,
      rows = _this$get.rows;

  var _this$group = this.group,
      onSelect = _this$group.onSelect,
      isChecked = _this$group.isChecked,
      getGroupText = _this$group.getGroupText;
  return _$cc(TableContext.Consumer, {
    'children': function children(checkType) {
      return _$cc(GroupContext.Consumer, {
        'children': function children(_ref) {
          var currentGroup = _ref.group,
              onChange = _ref.onChange;
          return _$cc(SortableContext.Consumer, {
            'children': function children(_ref2) {
              var sort = _sortInstanceProperty(_ref2),
                  onChangeSort = _ref2.onChange;

              return _$cc(ResizableContext.Consumer, {
                'children': function children(_ref3) {
                  var resizable = _ref3.resizable,
                      onStart = _ref3.onStart;
                  return _$cc(FixedColumnsContext.Consumer, {
                    'children': function children(offsetMap) {
                      var _classNameObj, _$cn2, _$cn3;

                      var _getClassAndStyleForF = getClassAndStyleForFixed(_this.get(), offsetMap[key], checkType),
                          className = _getClassAndStyleForF.className,
                          style = _getClassAndStyleForF.style;

                      var classNameObj = (_classNameObj = {
                        'k-column-sortable': sortable
                      }, _classNameObj[className] = className, _classNameObj);
                      var groupValue = currentGroup && currentGroup[key];
                      var groupText = getGroupText(groupValue);
                      var type = sort && sort.key === key && sort.type;
                      var checked;
                      return _$ce(2, 'th', [resizable && _this.$vNode.props.prevVNode ? _$ce(2, 'div', null, 1, 'k-table-resize', {
                        'ev-mousedown': function evMousedown(e) {
                          e._vNode = _this.$vNode;
                          onStart(e);
                        }
                      }) : undefined, _$ce(2, 'div', [_$ce(2, 'div', [(_$blocks['title'] = function ($super) {
                        return title;
                      }, __$blocks['title'] = function ($super, data) {
                        var block = $blocks['title'];

                        var callBlock = function callBlock() {
                          return _$blocks['title'].call($this, $super, data);
                        };

                        return block ? block.call($this, callBlock, data) : callBlock();
                      }, __$blocks['title'](_$no)), groupText], 0, 'k-table-title-text c-ellipsis'), group ? _$cc(Dropdown, {
                        'position': {
                          my: 'center top',
                          at: 'center bottom+5',
                          collision: 'flipfit'
                        },
                        'key': 'dropdown',
                        'children': [_$cc(Button, {
                          'icon': true,
                          'size': 'mini',
                          'className': 'k-table-group',
                          'children': _$cc(Icon, _$tmp0)
                        }), _$cc(DropdownMenu, {
                          'className': _$cn((_$cn2 = {
                            "k-group-dropdown": true
                          }, _$cn2[makeGroupMenuStyles()] = true, _$cn2)),
                          'children': _$ma(group, function ($value, $key) {
                            return _$cc(DropdownItem, {
                              'ev-select': function evSelect() {
                                return onSelect($value.value, groupValue, onChange);
                              },
                              'hideOnSelect': !multiple,
                              'className': _$cn({
                                'k-active': checked = isChecked($value.value, groupValue)
                              }),
                              'children': multiple ? _$cc(Checkbox, {
                                'value': checked,
                                'children': $value.label
                              }) : _$ce(2, 'span', $value.label, 0)
                            });
                          }, $this)
                        })]
                      }, 'dropdown') : undefined, sortable ? _$ce(2, 'div', [_$cc(Icon, _$tmp1), _$cc(Icon, _$tmp2)], 4, _$cn((_$cn3 = {
                        'k-column-sort': true
                      }, _$cn3["k-" + type] = type, _$cn3))) : undefined], 0, 'k-table-title')], 0, _$cn(classNameObj), {
                        'style': style,
                        'title': isStringOrNumber(title) ? title + (groupText || '') : null,
                        'ev-click': sortable ? linkEvent(key, onChangeSort) : null,
                        'colspan': cols,
                        'rowspan': rows
                      });
                    }
                  });
                }
              });
            }
          });
        }
      });
    }
  });
}
;