import _asyncToGenerator from "@babel/runtime-corejs3/helpers/asyncToGenerator";
import _regeneratorRuntime from "@babel/runtime-corejs3/regenerator";
import _trimInstanceProperty from "@babel/runtime-corejs3/core-js/instance/trim";
import { findDomFromVNode, createVNode as h, mount } from 'intact-vue-next';
import { loopDataWithChildrenKey } from './useTree';
import { get, noop, isNullOrUndefined } from 'intact-shared';
export function exportTable(_x, _x2, _x3, _x4, _x5) {
  return _exportTable.apply(this, arguments);
}

function _exportTable() {
  _exportTable = _asyncToGenerator( /*#__PURE__*/_regeneratorRuntime.mark(function _callee(getData, data, childrenKey, parentComponet, filename) {
    var download, collection, _getData, columns, cols, content;

    return _regeneratorRuntime.wrap(function _callee$(_context) {
      while (1) {
        switch (_context.prev = _context.next) {
          case 0:
            _context.next = 2;
            return import('downloadjs');

          case 2:
            download = _context.sent.default;
            collection = [];
            _getData = getData(), columns = _getData.columns, cols = _getData.cols; // head

            columns.forEach(function (column) {
              var rows = []; // TODO: support grouped header

              column.forEach(function (vNode) {
                var props = vNode.props;
                if (props.ignore) return;
                var dom = findDomFromVNode(vNode, true);
                pushTextContext(rows, dom, props.exportTitle);
              });
              collection.push(rows.join(','));
            }); // body

            loopDataWithChildrenKey(data, childrenKey, function (data, index) {
              var rows = [];
              cols.forEach(function (col) {
                if (col.ignore) return;
                var blocks = col.$blocks;
                var children = get(data, col.key);

                if (blocks) {
                  var template = blocks.template || blocks.default;

                  if (template) {
                    children = template(noop, [data, index]);
                  }
                }

                var td = h('td', null, children);
                mount(td, null, parentComponet, false, null, []);
                var exportCell = col.exportCell;
                var content = exportCell && exportCell(data, index);
                pushTextContext(rows, td.dom, content);
              });
              collection.push(rows.join(','));
            }, false);
            content = collection.join('\r\n');
            download("\uFEFF" + content, filename + '.csv', 'text/comma-separated-values;charset=utf-8');

          case 9:
          case "end":
            return _context.stop();
        }
      }
    }, _callee);
  }));
  return _exportTable.apply(this, arguments);
}

function pushTextContext(rows, dom, content) {
  var text = isNullOrUndefined(content) ? dom.textContent : content;
  text = '"' + String(_trimInstanceProperty(text).call(text)).replace(/"/g, '""') + '"';
  rows.push(text);
}