import { Component, VNodeComponentClass, Props, Key, IntactDom } from 'intact-vue-next';
import type { TableColumnProps } from './column';
import type { TableProps, TableRowKey } from './table';
import type { TableGrid } from './useMerge';
export interface TableRowProps {
    key: TableRowKey;
    data: any;
    cols: Props<TableColumnProps>[];
    checkType: TableProps['checkType'];
    hasFixedLeft: boolean;
    onClick: (data: any, index: number, key: TableRowKey) => void;
    checked: boolean;
    indeterminate: boolean;
    index: number;
    disabled: boolean;
    allDisabled: boolean;
    onChangeChecked: (index: number, checked: boolean) => void;
    grid: TableGrid;
    selected: boolean;
    hidden: boolean;
    spreaded: boolean;
    hasChildren: boolean;
    indent: number;
    onToggleSpreadRow: (key: TableRowKey) => void;
    onBeforeUnmount: (key: TableRowKey) => void;
    offsetMap: Record<Key, number>;
    draggable: boolean;
    draggingKey: TableRowKey | null;
    onRowDragStart: DragCallback;
    onRowDragOver: DragCallback;
    onRowDragEnd: DragCallback;
}
declare type DragCallback = (e: MouseEvent, tableRow: TableRow) => void;
export declare class TableRow extends Component<TableRowProps> {
    static template: import("intact").Template<any>;
    $update(lastVNode: VNodeComponentClass<this>, nextVNode: VNodeComponentClass<this>, parentDom: Element, anchor: IntactDom | null, mountedQueue: Function[], force: boolean): void;
    onClick(e: MouseEvent): void;
    onChangeChecked(v: boolean): void;
    onClickArrow(e: MouseEvent): void;
    onMouseEnter(e: MouseEvent): void;
    onMouseLeave(e: MouseEvent): void;
    onRowDragStart(e: MouseEvent): void;
    onRowDragOver(e: MouseEvent): void;
    onRowDragEnd(e: MouseEvent): void;
    beforeUnmount(): void;
}
export {};
