import _inheritsLoose from "@babel/runtime-corejs3/helpers/inheritsLoose";
import { __decorate } from "tslib";
import { Component } from 'intact-vue-next';
import template from './row.vdt';
import { bind } from '../utils';
export var TableRow = /*#__PURE__*/function (_Component) {
  _inheritsLoose(TableRow, _Component);

  function TableRow() {
    return _Component.apply(this, arguments) || this;
  }

  var _proto = TableRow.prototype;

  _proto.$update = function $update(lastVNode, nextVNode, parentDom, anchor, mountedQueue, force) {
    var lastProps = lastVNode.props;
    var nextProps = nextVNode.props;
    var isSame = true;
    var key;

    for (key in lastProps) {
      // ignore index
      if (key === 'index') continue;

      if (lastProps[key] !== nextProps[key]) {
        isSame = false;
        break;
      }
    }

    if (!isSame) {
      _Component.prototype.$update.call(this, lastVNode, nextVNode, parentDom, anchor, mountedQueue, force);
    } else {
      // should update index
      this.set(nextProps, {
        silent: true
      });
    }
  };

  _proto.onClick = function onClick(e) {
    if (e.target.tagName === 'INPUT') return;

    var _this$get = this.get(),
        index = _this$get.index,
        key = _this$get.key,
        data = _this$get.data,
        onClick = _this$get.onClick,
        disabled = _this$get.disabled;

    if (!disabled) {
      onClick(data, index, key);
    }
  };

  _proto.onChangeChecked = function onChangeChecked(v) {
    var _this$get2 = this.get(),
        index = _this$get2.index,
        onChangeChecked = _this$get2.onChangeChecked;

    onChangeChecked(index, v);
  };

  _proto.onClickArrow = function onClickArrow(e) {
    e.stopPropagation();

    var _this$get3 = this.get(),
        onToggleSpreadRow = _this$get3.onToggleSpreadRow,
        key = _this$get3.key;

    onToggleSpreadRow(key);
  };

  _proto.onMouseEnter = function onMouseEnter(e) {
    // for tooltip
    var mouseEnter = this.get('ev-mouseenter');
    mouseEnter && mouseEnter(e);
  };

  _proto.onMouseLeave = function onMouseLeave(e) {
    // for tooltip
    var mouseLeave = this.get('ev-mouseleave');
    mouseLeave && mouseLeave(e);
  };

  _proto.onRowDragStart = function onRowDragStart(e) {
    this.get('onRowDragStart')(e, this);
  };

  _proto.onRowDragOver = function onRowDragOver(e) {
    this.get('onRowDragOver')(e, this);
  };

  _proto.onRowDragEnd = function onRowDragEnd(e) {
    this.get('onRowDragEnd')(e, this);
  };

  _proto.beforeUnmount = function beforeUnmount() {
    this.get('onBeforeUnmount')(this.get('key'));
  };

  return TableRow;
}(Component);
TableRow.template = template;

__decorate([bind], TableRow.prototype, "onClick", null);

__decorate([bind], TableRow.prototype, "onChangeChecked", null);

__decorate([bind], TableRow.prototype, "onClickArrow", null);

__decorate([bind], TableRow.prototype, "onMouseEnter", null);

__decorate([bind], TableRow.prototype, "onMouseLeave", null);

__decorate([bind], TableRow.prototype, "onRowDragStart", null);

__decorate([bind], TableRow.prototype, "onRowDragOver", null);

__decorate([bind], TableRow.prototype, "onRowDragEnd", null);