import _extends from "@babel/runtime-corejs3/helpers/extends";
import _sortInstanceProperty from "@babel/runtime-corejs3/core-js/instance/sort";
import { createElementVNode as _$ce, map as _$ma, className as _$cn, createUnknownComponentVNode as _$cc, createVNode as _$cv, noop as _$no, extend as _$ex, EMPTY_OBJ as _$em } from 'intact-vue-next';
import { eachChildren } from '../utils';
import { makeStyles } from './styles';
import { isStringOrNumber, isNull } from 'intact-shared';
import { getClassAndStyleForFixed } from './useFixedColumns';
import { Affix } from '../affix';
import { TableRow } from './row';
import { Checkbox } from '../checkbox';
import { context as GroupContext } from './useGroup';
import { context as SortableContext } from './useSortable';
import { Spin } from '../spin';
import { Transition, TransitionGroup, createComponentVNode } from 'intact';
import { _$ } from '../../i18n';
import { context as TableContext } from './useColumns';
import { expandAnimationCallbacks } from '../utils';
import { Tooltip } from '../tooltip';
import { AllCheckedStatus } from './useChecked';
import { context as ResizableContext } from './useResizable';
import { context as FixedColumnsContext } from './useFixedColumns';
var _$tmp0 = {
  'width': '40'
};
var _$tmp1 = {
  'overlay': true,
  'size': 'small',
  'className': 'k-table-spin'
};
export default function ($props, $blocks, $__proto__) {
  var _classNameObj,
      _this = this;

  $blocks || ($blocks = {});
  $props || ($props = {});
  var $this = this;
  var _$blocks = {};
  var __$blocks = {};

  var _this$get = this.get(),
      data = _this$get.data,
      children = _this$get.children,
      className = _this$get.className,
      fixHeader = _this$get.fixHeader,
      checkType = _this$get.checkType,
      rowKey = _this$get.rowKey,
      type = _this$get.type,
      stripe = _this$get.stripe,
      rowClassName = _this$get.rowClassName,
      group = _this$get.group,
      sort = _sortInstanceProperty(_this$get),
      loading = _this$get.loading,
      merge = _this$get.merge,
      childrenKey = _this$get.childrenKey,
      indent = _this$get.indent,
      tooltipPosition = _this$get.tooltipPosition,
      tooltipContainer = _this$get.tooltipContainer,
      showIndeterminate = _this$get.showIndeterminate,
      resizable = _this$get.resizable,
      draggable = _this$get.draggable;

  var _this$columns$getData = this.columns.getData(),
      columns = _this$columns$getData.columns,
      cols = _this$columns$getData.cols,
      maxRows = _this$columns$getData.maxRows,
      maxCols = _this$columns$getData.maxCols;

  var _this$fixedColumns = this.fixedColumns,
      onScroll = _this$fixedColumns.onScroll,
      scrollPosition = _this$fixedColumns.scrollPosition,
      hasFixed = _this$fixedColumns.hasFixed,
      getHasFixedLeft = _this$fixedColumns.getHasFixedLeft,
      getOffsetMap = _this$fixedColumns.getOffsetMap;
  var _this$stickyHeader = this.stickyHeader,
      stickHeader = _this$stickyHeader.stickHeader,
      excludeStickHeader = _this$stickyHeader.excludeStickHeader,
      elementRef = _this$stickyHeader.elementRef,
      scrollRef = _this$stickyHeader.scrollRef,
      headRef = _this$stickyHeader.headRef;
  var classNameObj = (_classNameObj = {
    'k-table': true,
    'k-fix-header': fixHeader
  }, _classNameObj["k-scroll-" + scrollPosition.value] = scrollPosition.value, _classNameObj['k-fix-columns'] = hasFixed.value, _classNameObj["k-" + type] = type && type !== 'default', _classNameObj['k-stripe'] = stripe, _classNameObj['k-with-expand'] = $blocks.expand, _classNameObj[className] = className, _classNameObj[makeStyles()] = true, _classNameObj);
  var style = isStringOrNumber(fixHeader) ? {
    maxHeight: fixHeader + "px"
  } : null;
  var _this$resizable = this.resizable,
      getWidth = _this$resizable.getWidth,
      onStart = _this$resizable.start,
      tableRef = _this$resizable.tableRef,
      tableWidth = _this$resizable.tableWidth;

  var colgroup = _$ce(2, 'colgroup', [checkType !== 'none' ? _$ce(2, 'col', null, 1, null, _$tmp0) : undefined, _$ma(cols, function ($value, $key) {
    var _$cn2;

    return _$ce(2, 'col', null, 1, _$cn((_$cn2 = {}, _$cn2[$value.className] = $value.className, _$cn2)), {
      'width': $value.width,
      'style': {
        width: getWidth($value.key)
      }
    });
  }, $this)], 0);

  var hasData = data && data.length;
  var hasFixedLeft = getHasFixedLeft();
  var _this$checked = this.checked,
      getAllCheckedStatus = _this$checked.getAllCheckedStatus,
      toggleCheckedAll = _this$checked.toggleCheckedAll,
      getAllStatus = _this$checked.getAllStatus,
      onChangeChecked = _this$checked.onChangeChecked;
  var allCheckedStatus = getAllCheckedStatus();
  var offsetMap = getOffsetMap();

  var thead = _$cc(TableContext.Provider, {
    'value': checkType,
    'children': _$cc(GroupContext.Provider, {
      'value': {
        group: group,
        onChange: this.onChangeGroup
      },
      'children': _$cc(SortableContext.Provider, {
        'value': {
          sort: sort,
          onChange: this.sortable.onChange
        },
        'children': _$cc(ResizableContext.Provider, {
          'value': {
            resizable: resizable,
            onStart: onStart
          },
          'children': _$cc(FixedColumnsContext.Provider, {
            'value': offsetMap,
            'children': _$ce(2, 'thead', _$ma(columns, function ($value, $key) {
              return _$ce(2, 'tr', [$key === 0 && checkType !== 'none' ? _$cv('th', _extends({}, getClassAndStyleForFixed({
                fixed: hasFixedLeft ? 'left' : false
              }, 0), {
                'rowspan': maxRows
              }), checkType === 'checkbox' ? _$cc(Checkbox, {
                'value': allCheckedStatus === AllCheckedStatus.All,
                'indeterminate': showIndeterminate && allCheckedStatus == AllCheckedStatus.Indeterminate,
                'ev-$change:value': toggleCheckedAll,
                'disabled': !hasData
              }) : undefined) : undefined, $value], 0);
            }, $this), 4)
          })
        })
      })
    })
  });

  var getAllKeys = this.disableRow.getAllKeys;
  var getGrid = this.merge.getGrid;
  var allStatus = getAllStatus();
  var allKeys = getAllKeys();
  var colCount = maxCols + (checkType !== 'none' ? 1 : 0);
  var isExpanded = this.expandable.isExpanded;
  var isSelected = this.selected.isSelected;
  var _this$tree = this.tree,
      loopData = _this$tree.loopData,
      isSpreaded = _this$tree.isSpreaded,
      toggleSpreadRow = _this$tree.toggleSpreadRow;
  var _this$draggable = this.draggable,
      onRowDragStart = _this$draggable.onRowDragStart,
      onRowDragOver = _this$draggable.onRowDragOver,
      onRowDragEnd = _this$draggable.onRowDragEnd,
      draggingKey = _this$draggable.draggingKey;

  var tbody = _$cc(TransitionGroup, {
    'tag': 'tbody',
    'name': 'k-fade',
    'move': !draggingKey.value,
    'children': !hasData ? _$ce(2, 'tr', _$ce(2, 'td', (_$blocks['empty'] = function ($super) {
      return _$('/(ㄒoㄒ)/~~ 没有找到亲要的数据哦~');
    }, __$blocks['empty'] = function ($super, data) {
      var block = $blocks['empty'];

      var callBlock = function callBlock() {
        return _$blocks['empty'].call($this, $super, data);
      };

      return block ? block.call($this, callBlock, data) : callBlock();
    }, __$blocks['empty'](_$no)), 0, 'k-table-empty', {
      'colspan': colCount
    }), 2, null, null, 'table-empty') : function () {
      var rows = [];
      loopData(function (value, index, level, hidden) {
        var status = allStatus[index];
        var key = allKeys[index];
        var spreaded = isSpreaded(key);
        var hasChildren = !!childrenKey && Array.isArray(value[childrenKey]);
        var indentSize = indent ? indent * level : 0;

        var row = _$cc(TableRow, {
          'key': key,
          'cols': cols,
          'data': value,
          'checkType': checkType,
          'hasFixedLeft': hasFixedLeft,
          'onClick': _this.clickRow,
          'checked': status.checked,
          'indeterminate': status.indeterminate,
          'index': index,
          'disabled': status.disabled,
          'allDisabled': status.allDisabled,
          'className': _$cn(rowClassName && rowClassName(value, index, key)),
          'merge': merge,
          'grid': getGrid(),
          'onChangeChecked': onChangeChecked,
          'selected': isSelected(key),
          'spreaded': spreaded,
          'hidden': hidden,
          'hasChildren': hasChildren,
          'indent': indentSize,
          'onToggleSpreadRow': toggleSpreadRow,
          'onBeforeUnmount': _this.resetRowStatus.onRowBeforeUnmount,
          'offsetMap': offsetMap,
          'draggable': draggable,
          'draggingKey': draggingKey.value,
          'onRowDragStart': onRowDragStart,
          'onRowDragEnd': onRowDragEnd,
          'onRowDragOver': onRowDragOver
        }, key);

        if ($blocks.tooltip) {
          var content = (_$blocks['tooltip'] = function ($super) {
            return null;
          }, __$blocks['tooltip'] = function ($super, data) {
            var block = $blocks['tooltip'];

            var callBlock = function callBlock() {
              return _$blocks['tooltip'].call($this, $super, data);
            };

            return block ? block.call($this, callBlock, data) : callBlock();
          }, __$blocks['tooltip'](_$no, [value, index]));
          row = _$cc(Tooltip, {
            'key': key,
            'position': tooltipPosition,
            'container': tooltipContainer,
            'children': row,
            '$blocks': function ($blocks) {
              var _$blocks = {},
                  __$blocks = _$ex({}, $blocks);

              return (_$blocks['content'] = function ($super) {
                return content;
              }, __$blocks['content'] = function ($super, data) {
                var block = $blocks['content'];

                var callBlock = function callBlock() {
                  return _$blocks['content'].call($this, $super, data);
                };

                return block ? block.call($this, callBlock, data) : callBlock();
              }), __$blocks;
            }.call($this, _$em)
          }, key);
        }

        rows.push(row);

        if ($blocks.expand) {
          var expanded = isExpanded(key);
          rows.push(_$ce(2, 'tr', _$ce(2, 'td', _$cc(Transition, _extends({}, expandAnimationCallbacks, {
            'children': expanded ? _$ce(2, 'div', (_$blocks['expand'] = function ($super) {
              return null;
            }, __$blocks['expand'] = function ($super, data) {
              var block = $blocks['expand'];

              var callBlock = function callBlock() {
                return _$blocks['expand'].call($this, $super, data);
              };

              return block ? block.call($this, callBlock, data) : callBlock();
            }, __$blocks['expand'](_$no, [value, index])), 0, 'k-table-expand') : undefined
          })), 2, null, {
            'colspan': colCount
          }), 2, _$cn({
            "k-expand": true,
            'k-expanded': expanded
          }), null, key + ".$expand"));
        }

        return hidden || !spreaded;
      });
      return rows;
    }()
  });

  var tableWidthPx = tableWidth.value ? tableWidth.value + "px" : null;
  return _$ce(2, 'div', [_$ce(2, 'div', [!isNull(stickHeader.value) ? _$cc(Affix, {
    'top': stickHeader.value,
    'exclude': excludeStickHeader,
    'className': 'k-table-affix-header',
    'children': _$ce(2, 'table', [colgroup, thead], 0, null, {
      'style': {
        width: tableWidthPx
      }
    }, null, headRef)
  }) : undefined, _$ce(2, 'table', [colgroup, isNull(stickHeader.value) ? thead : undefined, tbody], 0, null, {
    'style': {
      width: tableWidthPx
    }
  }, null, tableRef)], 0, 'k-table-wrapper', {
    'style': style,
    'ev-scroll': onScroll
  }, null, scrollRef), _$cc(Transition, {
    'name': 'k-fade',
    'children': loading ? _$cc(Spin, _$tmp1) : undefined
  })], 4, _$cn(classNameObj), null, null, elementRef);
}
;