import type { TableRowKey } from './';
import type { TableGrid } from './useMerge';
import type { useTree } from './useTree';
declare type RowStatus = {
    checked: boolean;
    indeterminate: boolean;
    disabled: boolean;
    allDisabled: boolean;
};
export declare enum AllCheckedStatus {
    All = 0,
    Indeterminate = 1,
    None = 2
}
export declare function useChecked(getEnableKeys: () => TableRowKey[], getAllKeys: () => TableRowKey[], isDisabledKey: (key: TableRowKey) => boolean, getGrid: () => TableGrid, loopData: ReturnType<typeof useTree>['loopData']): {
    isChecked: (key: TableRowKey) => boolean;
    getAllCheckedStatus: () => AllCheckedStatus;
    toggleCheckedAll: (v: boolean) => void;
    getAllStatus: () => RowStatus[];
    onChangeChecked: (rowIndex: number, v: boolean) => void;
};
export declare function inArray<T>(arr: T[] | undefined, v: T): boolean;
export declare function addOrRemove(keys: TableRowKey[], key: TableRowKey, isAdd: boolean): void;
export {};
