import _sliceInstanceProperty from "@babel/runtime-corejs3/core-js/instance/slice";
import _spliceInstanceProperty from "@babel/runtime-corejs3/core-js/instance/splice";
import { useInstance, nextTick } from 'intact-vue-next';
import { useState } from '../../hooks/useState';
export function useDraggable() {
  var instance = useInstance();
  var draggingKey = useState(null);
  var originIndex;
  var originData;
  var draggingIndex;

  function onRowDragStart(e, tableRow) {
    draggingIndex = originIndex = tableRow.get('index');
    var key = tableRow.get('key');
    draggingKey.set(key);
    originData = instance.get('data');
    instance.trigger('dragstart', {
      key: key,
      from: draggingIndex
    });
  }

  function onRowDragOver(e, tableRow) {
    var _context;

    e.preventDefault();
    e.stopPropagation();
    var newIndex = tableRow.get('index');
    if (newIndex === draggingIndex) return; // swap data

    var data = _sliceInstanceProperty(_context = instance.get('data')).call(_context);

    var item = _spliceInstanceProperty(data).call(data, draggingIndex, 1)[0];

    _spliceInstanceProperty(data).call(data, newIndex, 0, item);

    draggingIndex = newIndex;
    instance.set('data', data);
  }

  function onRowDragEnd(e, tableRow) {
    e.preventDefault();
    instance.set('data', originData);
    nextTick(function () {
      draggingKey.set(null);
      instance.trigger('dragend', {
        key: tableRow.get('key'),
        from: originIndex,
        to: draggingIndex
      });
    });
  }

  return {
    onRowDragStart: onRowDragStart,
    onRowDragOver: onRowDragOver,
    onRowDragEnd: onRowDragEnd,
    draggingKey: draggingKey
  };
}