import { VNodeComponentClass, Props, RefObject, Key } from 'intact-vue-next';
import { TableColumn, TableColumnProps } from './column';
import type { TableProps, TableRowKey } from './table';
import { State } from '../../hooks/useState';
declare type ScrollPosition = 'left' | 'middle' | 'right';
export declare const context: {
    Provider: import("intact").ComponentConstructor<import("intact").Component<import("../context").ProviderProps<any>, {}, {}, {}>>;
    Consumer: import("intact").ComponentConstructor<import("intact").Component<{}, {}, {}, {}>>;
};
export declare function useFixedColumns(getColumns: () => VNodeComponentClass<TableColumn>[][], scrollRef: RefObject<HTMLElement>, widthMap: State<Record<TableRowKey, number>>): {
    scrollPosition: State<ScrollPosition | null>;
    onScroll: (e: Event) => void;
    hasFixed: State<boolean>;
    getHasFixedLeft: () => boolean;
    getOffsetMap: () => Record<Key, number>;
};
export declare function getClassAndStyleForFixed({ className, fixed }: Props<TableColumnProps>, offset: number, checkType?: TableProps['checkType']): {
    className: string;
    style: {
        [x: string]: string;
    } | null;
};
export {};
