import _includesInstanceProperty from "@babel/runtime-corejs3/core-js/instance/includes";
import _mapInstanceProperty from "@babel/runtime-corejs3/core-js/instance/map";
import _filterInstanceProperty from "@babel/runtime-corejs3/core-js/instance/filter";
import { useInstance } from 'intact-vue-next';
import { isNullOrUndefined } from 'intact-shared';
import { toggleArray } from '../utils';
import { createContext } from '../context';
export var context = createContext();
export function useGroup() {
  var instance = useInstance();

  function onSelect(value, groupValue, onChange) {
    var _instance$get = instance.get(),
        multiple = _instance$get.multiple,
        key = _instance$get.key;

    if (multiple) {
      value = toggleArray(groupValue, value);
    }

    onChange(key, value);
  }

  function isChecked(value, groupValue) {
    var _instance$get2 = instance.get(),
        multiple = _instance$get2.multiple;

    if (multiple) {
      return groupValue && _includesInstanceProperty(groupValue).call(groupValue, value);
    }

    return groupValue === value;
  }

  function getGroupText(groupValue) {
    var _instance$get3 = instance.get(),
        multiple = _instance$get3.multiple,
        group = _instance$get3.group;

    if (isNullOrUndefined(groupValue)) return null;

    if (!multiple) {
      groupValue = [groupValue];
    }

    if (group) {
      var _context;

      var ret = _mapInstanceProperty(_context = _filterInstanceProperty(group).call(group, function (item) {
        return _includesInstanceProperty(groupValue).call(groupValue, item.value);
      })).call(_context, function (item) {
        return item.label;
      }).join(', ');

      if (ret) {
        return "(" + ret + ")";
      }
    }

    return null;
  }

  return {
    onSelect: onSelect,
    isChecked: isChecked,
    getGroupText: getGroupText
  };
}