import { TypeDefs } from 'intact-vue-next';
import { BasePicker } from '../datepicker/basepicker';
import dayjs from '../datepicker/dayjs';
import { State } from '../../hooks/useState';
import { PanelTypes } from '../datepicker/usePanel';
import { TimepickerProps, TimepickerEvents, TimepickerBlocks } from './constants';
export declare class PanelPicker extends BasePicker<TimepickerProps, TimepickerEvents, TimepickerBlocks> {
    static template: import("intact").Template<any>;
    static typeDefs: Required<TypeDefs<TimepickerProps>>;
    formats: {
        getValueFormat: () => string;
        getShowFormat: () => string;
        createDateByValueFormat: (value: import("../datepicker/basepicker").Value) => dayjs.Dayjs;
        createDateByShowFormat: (value: import("../datepicker/basepicker").Value) => dayjs.Dayjs;
        getShowString: (value: dayjs.Dayjs) => string;
        getValueString: (value: dayjs.Dayjs) => string;
    };
    disabled: {
        isDisabled: (value: dayjs.Dayjs, type?: "second" | "month" | "year" | "date") => boolean;
        isDisabledConfirm: () => boolean;
        maxDate: State<dayjs.Dayjs | null>;
        minDate: State<dayjs.Dayjs | null>;
        isDisabledTime: (value: dayjs.Dayjs, flag: import("../datepicker/usePanel").PanelFlags) => boolean;
        isDisabledTimeByStep: (value: string, flag: import("../datepicker/usePanel").PanelFlags) => boolean;
    };
    panel: {
        startPanel: State<PanelTypes>;
        endPanel: State<PanelTypes>;
        changePanel: (type: PanelTypes, flag?: import("../datepicker/usePanel").PanelFlags) => void;
        getPanel: (flag: import("../datepicker/usePanel").PanelFlags) => State<PanelTypes>;
        reset: () => void;
        startRef: import("intact").RefObject<import("../datepicker/calendar").DatepickerCalendar>;
        endRef: import("intact").RefObject<import("../datepicker/calendar").DatepickerCalendar>;
    };
    value: {
        format: () => string | string[];
        onConfirm: () => void;
        getTimeValue: (flag: import("../datepicker/usePanel").PanelFlags) => dayjs.Dayjs | null | undefined;
        convertToDayjs: (v: import("../datepicker/basepicker").Value | import("../datepicker/basepicker").Value[] | [import("../datepicker/basepicker").Value, import("../datepicker/basepicker").Value] | [import("../datepicker/basepicker").Value, import("../datepicker/basepicker").Value][] | null | undefined) => import("../datepicker/basepicker").DayjsValue;
        value: State<import("../datepicker/basepicker").StateValue>;
        setValue: (v: import("../datepicker/basepicker").StateValueItem, fromInput: boolean) => void;
        getDayjsValue: () => import("../datepicker/basepicker").DayjsValue;
        onChangeTime: (date: dayjs.Dayjs, flag: import("../datepicker/usePanel").PanelFlags) => void;
        onChangeTimeByStep: (v: string, flag: import("../datepicker/usePanel").PanelFlags) => void;
    };
    step: {
        options: State<{
            value: string;
            label: string;
        }[] | null>;
    };
    protected getPlaceholder(): string | number | boolean | import("misstime/dist/utils/types").VNode<any> | import("intact").Children[];
    protected getLabel(): string | string[];
}
