import { Component, TypeDefs } from 'intact-vue-next';
import { TimepickerProps, TimepickerEvents, TimepickerBlocks } from './constants';
export declare class SelectPicker extends Component<TimepickerProps, TimepickerEvents, TimepickerBlocks> {
    static template: import("intact").Template<any>;
    static typeDefs: Required<TypeDefs<TimepickerProps>>;
    formats: {
        getValueFormat: () => string;
        getShowFormat: () => string;
        createDateByValueFormat: (value: import("../datepicker/basepicker").Value) => import("dayjs").Dayjs;
        createDateByShowFormat: (value: import("../datepicker/basepicker").Value) => import("dayjs").Dayjs;
        getShowString: (value: import("dayjs").Dayjs) => string;
        getValueString: (value: import("dayjs").Dayjs) => string;
    };
    disabled: {
        isDisabled: (value: import("dayjs").Dayjs, type?: "second" | "month" | "year" | "date") => boolean;
        isDisabledTime: (value: import("dayjs").Dayjs, flag: import("../datepicker/usePanel").PanelFlags) => boolean;
        isDisabledConfirm: () => boolean;
        maxDate: import("../../hooks/useState").State<import("dayjs").Dayjs | null>;
        minDate: import("../../hooks/useState").State<import("dayjs").Dayjs | null>;
    };
    step: {
        options: import("../../hooks/useState").State<{
            value: string;
            label: string;
        }[] | null>;
    };
}
