import { TypeDefs, Children } from 'intact-vue-next';
import { Dropdown, DropdownProps, DropdownEvents, DropdownBlocks } from '../dropdown/dropdown';
import { Theme } from './styles';
export interface TooltipProps extends DropdownProps {
    showArrow?: boolean;
    theme?: Theme;
    hoverable?: boolean;
    always?: boolean;
    confirm?: boolean;
    okText?: string;
    cancelText?: string;
    size?: 'small' | 'default';
    content?: Children;
}
export interface TooltipEvents extends DropdownEvents {
    ok: [];
    cancel: [];
}
export interface TooltipBlocks extends DropdownBlocks {
}
export declare const typeDefs: Required<TypeDefs<TooltipProps>>;
export declare const defaults: () => Partial<TooltipProps>;
export declare class Tooltip<T extends TooltipProps = TooltipProps, E extends TooltipEvents = TooltipEvents, B extends TooltipBlocks = TooltipBlocks> extends Dropdown<T, E, B> {
    static typeDefs: Required<TypeDefs<TooltipProps>>;
    static defaults: () => Partial<TooltipProps>;
    hide(immediately: boolean): void;
}
