import _inheritsLoose from "@babel/runtime-corejs3/helpers/inheritsLoose";
import _extends from "@babel/runtime-corejs3/helpers/extends";
import { Dropdown, defaults as dropdownDefaults, typeDefs as dropdownTypeDefs } from '../dropdown/dropdown';
import { _$ } from '../../i18n';
import { themes } from './styles';
export var typeDefs = _extends({}, dropdownTypeDefs, {
  showArrow: Boolean,
  theme: themes,
  hoverable: Boolean,
  always: Boolean,
  confirm: Boolean,
  okText: String,
  cancelText: String,
  size: ['small', 'default'],
  content: null
});
export var defaults = function defaults() {
  return _extends({}, dropdownDefaults(), {
    showArrow: true,
    theme: 'dark',
    position: {
      my: 'center bottom-10',
      at: 'center top',
      collision: 'flipfit'
    },
    hoverable: false,
    always: false,
    confirm: false,
    okText: _$('确定'),
    cancelText: _$('取消'),
    size: 'default'
  });
};
export var Tooltip = /*#__PURE__*/function (_Dropdown) {
  _inheritsLoose(Tooltip, _Dropdown);

  function Tooltip() {
    return _Dropdown.apply(this, arguments) || this;
  }

  var _proto = Tooltip.prototype;

  _proto.hide = function hide(immediately) {
    if (this.get('always')) return;

    if (this.get('hoverable')) {
      return _Dropdown.prototype.hide.call(this, immediately);
    }

    _Dropdown.prototype.hide.call(this, true);
  };

  return Tooltip;
}(Dropdown);
Tooltip.typeDefs = typeDefs;
Tooltip.defaults = defaults;