import { Component, TypeDefs, VNode, Key } from 'intact-vue-next';
import { Model } from './useFilter';
export interface TransferProps<T> {
    data?: T[];
    keyName?: string;
    labelName?: string;
    value?: Key[];
    leftCheckedKeys?: Key[];
    rightCheckedKeys?: Key[];
    filterable?: boolean;
    filter?: (data: T, keywords: string) => boolean;
    placeholder?: string;
    leftKeywords?: string;
    rightKeywords?: string;
    leftTitle?: string | VNode;
    rightTitle?: string | VNode;
    enableAdd?: () => boolean;
    enableRemove?: () => boolean;
}
export interface TransferEvents {
    add: [];
    remove: [];
}
export interface TransferBlocks<T> {
    header: Model;
    filter: Model;
    list: Model;
    label: [T, Key, Model];
}
export declare class Transfer<T = any> extends Component<TransferProps<T>, TransferEvents, TransferBlocks<T>> {
    static template: import("intact").Template<any>;
    static typeDefs: Required<TypeDefs<TransferProps<any>>>;
    static defaults: () => Partial<TransferProps<any>>;
    private transfer;
    private filter;
    private check;
    getData(): any[];
    getCheckedData(model: Model): any[];
}
