import { Component, Key, TypeDefs } from 'intact-vue-next';
import { DataItem, Node } from './useNodes';
import { Mode } from './useDraggable';
export interface TreeProps {
    data?: DataItem[];
    filter?: Filter;
    uncorrelated?: boolean;
    checkedKeys?: Key[];
    expandedKeys?: Key[];
    defaultExpandAll?: boolean;
    selectable?: boolean;
    selectedKeys?: Key[];
    multiple?: boolean;
    checkbox?: boolean;
    load?: (node: Node) => DataItem[] | Promise<DataItem[]>;
    showLine?: boolean;
    draggable?: boolean;
    allowDrag?: (node: Node) => boolean;
    allowDrop?: (node: Node) => boolean;
}
export interface TreeEvents {
    denydrag: [Node];
    denydrop: [Node];
    dragend: [DragEndData];
    transitionEnd: [];
}
export interface TreeBlocks {
    label: [DataItem, Node, number];
}
declare type DragEndData = {
    srcNode: Node;
    toNode: Node;
    mode: Mode;
};
declare type Filter = (data: DataItem, node: Node) => boolean;
export declare class Tree extends Component<TreeProps, TreeEvents, TreeBlocks> {
    static template: import("intact").Template<any>;
    static typeDefs: Required<TypeDefs<TreeProps>>;
    static defaults: () => Partial<TreeProps>;
    private nodes;
    private checked;
    private expanded;
    private selected;
    private filter;
    private draggable;
    private transition;
    getCheckedData(leafOnly?: boolean): DataItem[];
    getSelectedData(): DataItem[];
    expand(key: Key): void;
    shrink(key: Key): void;
    getNodes(): Node[];
    private onClick;
}
export {};
