import _extends from "@babel/runtime-corejs3/helpers/extends";
import _mapInstanceProperty from "@babel/runtime-corejs3/core-js/instance/map";
import _filterInstanceProperty from "@babel/runtime-corejs3/core-js/instance/filter";
import { createElementVNode as _$ce, createUnknownComponentVNode as _$cc, noop as _$no, className as _$cn, createVNode as _$cv } from 'intact-vue-next';
import { Transition, TransitionGroup, linkEvent } from 'intact';
import { Checkbox } from '../checkbox';
import { getRestProps } from '../utils';
import { makeStyles } from './styles';
import { Icon } from '../icon';
import { Mode } from './useDraggable';
var _$tmp0 = {
  'className': 'k-tree-icon ion-load-c',
  'rotate': true
};
export default function ($props, $blocks, $__proto__) {
  var _this = this,
      _classNameObj;

  $blocks || ($blocks = {});
  $props || ($props = {});
  var $this = this;
  var _$blocks = {};
  var __$blocks = {};

  var _this$get = this.get(),
      className = _this$get.className,
      checkbox = _this$get.checkbox,
      showLine = _this$get.showLine,
      selectable = _this$get.selectable,
      draggable = _this$get.draggable;

  var expandedKeys = this.expanded.get();
  var toggleExpanded = this.expanded.toggle;
  var toggleChecked = this.checked.toggle;
  var selectedKeys = this.selected.get();
  var toggleSelected = this.selected.toggle;
  var _this$draggable = this.draggable,
      onDragStart = _this$draggable.onDragStart,
      onDragOver = _this$draggable.onDragOver,
      onDragEnd = _this$draggable.onDragEnd,
      draggingKey = _this$draggable.draggingKey,
      overKey = _this$draggable.overKey,
      mode = _this$draggable.mode;

  var treeNodes = function treeNodes(nodes) {
    return _mapInstanceProperty(nodes).call(nodes, function (node, index) {
      if (!_filterInstanceProperty(node)) return;
      var key = node.key;
      var expanded = expandedKeys.has(key);
      var data = node.data;
      var disabled = data.disabled;
      var selected = selectable && selectedKeys.has(key);
      var classNameObj = {
        'k-tree-node': true,
        'k-expanded': expanded,
        'k-disabled': disabled,
        'k-selected': selected,
        'k-dragging': key === draggingKey.value
      };
      var labelClassNameObj = {
        'k-tree-label': true,
        'k-tree-leaf': !node.children
      };

      if (key === overKey.value) {
        switch (mode.value) {
          case Mode.Before:
            labelClassNameObj['k-before'] = true;
            break;

          case Mode.After:
            labelClassNameObj['k-after'] = true;
            break;

          case Mode.Inner:
            labelClassNameObj['k-inner'] = true;
            break;
        }
      }

      return _$ce(2, 'div', [_$ce(2, 'div', [node.children && node.loaded !== false ? _$cc(Icon, {
        'className': 'k-tree-icon ion-android-arrow-dropdown',
        'ev-click': function evClick(e) {
          // it may be in dropdownMenu, e.g. TreeSelect
          e._ignore = true;
          toggleExpanded(node);
        }
      }) : undefined, node.loaded === false ? _$cc(Icon, _$tmp0) : undefined, checkbox ? _$cc(Checkbox, {
        'value': node.checked,
        'disabled': disabled,
        'indeterminate': node.indeterminate,
        'ev-$change:value': function ev$changeValue() {
          return toggleChecked(node);
        },
        'className': 'k-tree-checkbox'
      }) : undefined, _$ce(2, 'div', (_$blocks['label'] = function ($super) {
        return data.label;
      }, __$blocks['label'] = function ($super, data) {
        var block = $blocks['label'];

        var callBlock = function callBlock() {
          return _$blocks['label'].call($this, $super, data);
        };

        return block ? block.call($this, callBlock, data) : callBlock();
      }, __$blocks['label'](_$no, [data, node, index])), 0, 'k-tree-text c-ellipsis', {
        'ev-click': linkEvent(node, _this.onClick)
      })], 0, _$cn(labelClassNameObj)), _$cc(Transition, _extends({}, _this.transition, {
        'children': expanded && node.children ? _$ce(2, 'div', _$cc(TransitionGroup, _extends({}, _this.transition, {
          'children': treeNodes(node.children)
        })), 2, 'k-tree') : undefined
      }))], 4, _$cn(classNameObj), {
        'draggable': draggable ? true : null,
        'ev-dragstart': draggable && linkEvent(node, onDragStart),
        'ev-dragover': draggable && linkEvent(node, onDragOver),
        'ev-dragend': draggable && onDragEnd
      }, key);
    });
  };

  var classNameObj = (_classNameObj = {
    'k-tree': true,
    'k-line': showLine,
    'k-selectable': selectable
  }, _classNameObj[className] = className, _classNameObj[makeStyles()] = true, _classNameObj);
  return _$cv('div', _extends({
    'className': _$cn(classNameObj)
  }, getRestProps(this)), _$cc(TransitionGroup, _extends({}, this.transition, {
    'children': treeNodes(this.nodes.getNodes())
  })));
}
;