import { TypeDefs, Children, Key } from 'intact-vue-next';
import { BaseSelect, BaseSelectProps, BaseSelectEvents, BaseSelectBlocks } from '../select/base';
import { TreeProps } from '../tree';
import type { DataItem } from '../tree/useNodes';
export interface TreeSelectProps extends BaseSelectProps {
    value?: Key | Key[];
    data?: TreeProps['data'];
    uncorrelated?: TreeProps['uncorrelated'];
    load?: TreeProps['load'];
    showLine?: TreeProps['showLine'];
    defaultExpandAll?: TreeProps['defaultExpandAll'];
    checkbox?: TreeProps['checkbox'];
    filter?: (keywords: string, data: DataItem) => boolean;
}
export interface TreeSelectEvents extends BaseSelectEvents {
}
export interface TreeSelectBlocks extends BaseSelectBlocks {
}
export declare class TreeSelect extends BaseSelect<TreeSelectProps, TreeSelectEvents, TreeSelectBlocks> {
    static template: import("intact").Template<any>;
    static typeDefs: Required<TypeDefs<TreeSelectProps>>;
    static defaults: () => Partial<TreeSelectProps>;
    private value;
    init(): void;
    protected getPlaceholder(): string | number | boolean | import("misstime/dist/utils/types").VNode<any> | Children[];
    protected getLabel(): Children;
    private filter;
}
