export declare type Options = {
    action?: string;
    headers?: Record<string | number, string>;
    data: any;
    withCredentials?: boolean;
    onProgress: (e: ProgressEvent, percent: number, xhr: XMLHttpRequest) => void;
    onError: (err: RequestError, xhr: XMLHttpRequest) => void;
    onSuccess: (res: any, xhr: XMLHttpRequest) => void;
};
export interface RequestError extends Error {
    status: number;
    method: string;
    url: string;
    response: any;
    xhr: XMLHttpRequest;
}
export declare function request(options: Options): {
    abort(): void;
};
