import { Component, TypeDefs } from 'intact-vue-next';
import { UploadFileStatus } from './useUpload';
import type { RequestError } from './ajaxUploader';
export interface UploadProps {
    accept?: string;
    files?: UploadFile[];
    defaultFiles?: UploadFile[];
    maxSize?: number;
    limit?: number;
    autoUpload?: boolean;
    beforeRemove?: BeforeCallback;
    beforeUpload?: BeforeCallback;
    data?: DataObject | DataFunction;
    action?: string;
    headers?: Record<string | number, string>;
    name?: string;
    withCredentials?: boolean;
    type?: 'select' | 'drag' | 'gallery';
    directory?: boolean;
    disabled?: boolean;
    multiple?: boolean;
}
export interface UploadEvents {
    progress: [ProgressEvent, XMLHttpRequest, UploadFile, UploadFile[]];
    success: [any, XMLHttpRequest, UploadFile, UploadFile[]];
    error: [Error | RequestError, File[] | File | UploadFile, UploadFile[]];
}
export interface UploadBlocks {
    content: null;
    children: null;
    tip: null;
}
export declare type UploadFile = {
    status: UploadFileStatus;
    type?: string;
    size?: number;
    name: string;
    percent: number;
    uid: number;
    raw: File | UploadFile;
    url?: string;
    request?: any;
};
declare type BeforeCallback = (file: UploadFile, files: UploadFile[]) => Promise<boolean> | boolean;
declare type DataObject = Record<string | number, any>;
declare type DataFunction = (file: UploadFile) => DataObject;
export declare class Upload extends Component<UploadProps, UploadEvents, UploadBlocks> {
    static template: import("intact").Template<any>;
    static typeDefs: Required<TypeDefs<UploadProps>>;
    static defaults: () => Partial<UploadProps>;
    private inputRef;
    private accept;
    private upload;
    private files;
    private drag;
    private showImage;
    submit(): void;
    private selectFile;
    private onInputChange;
}
export {};
