import { Component, VNode, Children, VNodeComponentClass, ComponentConstructor } from 'intact-vue-next';
export declare function bind<T extends Function>(target: any, key: string, descriptor: TypedPropertyDescriptor<T>): TypedPropertyDescriptor<T>;
export declare function addStyle(style: string | Record<string, string | null> | undefined, extra: Record<string, string | null>): string | Record<string, string | null>;
export declare function kebabCase(word: string): string;
export declare function isTextChildren(o: any): boolean;
export declare function isTextVNode(o: VNode): boolean;
export declare function isTextBlock(o: any): boolean;
export declare function isStringOrNumberNotEmpty(o: any): o is string | number;
export declare function getRestProps<T>(component: Component<T>, props?: import("intact").Props<T, Component<T, {}, {}, {}>>): Partial<T>;
export declare function isExternalLink(to?: string): boolean;
export declare function clamp(number: number, lower: number, upper: number): number;
export declare function stopPropagation(e: Event): void;
export declare type ValidVNode = VNode | string | number;
export declare type MapCallback<T> = (vNode: ValidVNode, index: number) => T;
export declare function findChildren(children: Children, callback: MapCallback<boolean>): ValidVNode | undefined;
export declare function mapChildren<T>(children: Children, callback: MapCallback<T>): T[];
export declare function eachChildren(children: Children, callback: MapCallback<void>): void;
export declare function toggleArray(arr: any[] | null | undefined, value: any): any[];
export declare function getTextByChildren(children: Children): string;
export declare function isEmptyString(o: any): boolean;
export declare function isEmptyChildren(o: Children): boolean;
export declare function isComponentVNode<T extends ComponentConstructor>(o: any, tag: T): o is VNodeComponentClass<T extends ComponentConstructor<infer P> ? P : never>;
export declare function range(start: number, end: number): number[];
export declare function strPad(str: number | string, length: number, pad?: string): string;
declare type EqualArrayValue = any | EqualArrayValue[];
export declare function isEqualArray(a: EqualArrayValue, b: EqualArrayValue): boolean;
export declare function last<T>(arr: T[]): T | undefined;
export declare const expandAnimationCallbacks: {
    name: string;
    onLeave: (el: HTMLElement) => void;
    onAfterLeave: (el: HTMLElement) => void;
    onBeforeEnter: (el: HTMLElement) => void;
    onEnter: (el: HTMLElement) => void;
    onAfterEnter: (el: HTMLElement) => void;
};
export declare function throttle<T>(fn: (arg: T) => void, time: number, doAlways?: (arg: T) => void): (arg: T) => void;
export declare function nextFrame(fn: () => void): void;
export {};
