import { onMounted, onUnmounted } from 'intact-vue-next';
import { isFunction } from 'intact-shared';
export function useDocumentClick(ref, callback, manual) {
  if (manual === void 0) {
    manual = false;
  }

  var onDocumentClick = function onDocumentClick(e) {
    if (e._ignore) return;
    var target = e.target;
    var elem = isFunction(ref) ? ref() : ref.value;
    if (containsOrEqual(elem, target)) return;
    callback(e);
  };

  var add = function add() {
    document.addEventListener('click', onDocumentClick);
    document.addEventListener('contextmenu', onDocumentClick);
  };

  var remove = function remove() {
    document.removeEventListener('click', onDocumentClick);
    document.removeEventListener('contextmenu', onDocumentClick);
  };

  if (!manual) {
    onMounted(add);
  }

  onUnmounted(remove);
  return [add, remove];
}
export function containsOrEqual(elem, target) {
  return target === elem || elem.contains(target);
}