import { onMounted, onBeforeUnmount } from 'intact-vue-next';
import ResizeObserver from 'resize-observer-polyfill';
export function useResizeObserver(elementRef, callback) {
  var ro;
  onMounted(function () {
    ro = new ResizeObserver(callback);
    ro.observe(elementRef.value);
  });
  onBeforeUnmount(function () {
    if (ro) {
      ro.disconnect();
    }
  });
}