export declare type Listener<T> = (newValue: T, oldValue: T) => void;
export declare type State<T> = {
    readonly value: T;
    set(value: T): void;
    listeners: Listener<T>[] | null;
};
export declare function useState<T>(value: T, isEqual?: (a: T, b: T) => boolean): State<T>;
export declare function watchState<T>(state: State<T>, callback: Listener<T>): void;
